#!/bin/csh -f
#
# Usage test.ml [working_directory]
#
   if ($#argv != 0) then
      set wrkdir = $argv[1]
   else
      set wrkdir = `pwd`
   endif
#
   cd $wrkdir
#
   set multidir = `cat ~/.multi_path3.0.1`
   set scriptdir = $multidir/script
   set basisdir = $multidir/basis
   set exedir = $multidir/exe
   set exe = $exedir/multilev.exe
#
#  Copy over the shuttles for the electronic structure program
#    to be use
#
   cp $scriptdir/g98shuttle $wrkdir/g98shuttle
   cp $scriptdir/g94shuttle $wrkdir/g94shuttle
#
#  Copy over the basis sets
#
   cp $basisdir/*.gbs $wrkdir
#
   foreach i (test4 )
      cp ${i}.dat ml.inp
      (time $exe) >& ${i}.jobs
      echo " " >> ${i}.jobs
      mv ml.out ${i}.out  >>& /dev/null
      mv ml.sum ${i}.sum  >>& /dev/null
      rm extopt.inp >>& /dev/null
      mv extopt.out ${i}.extopt >>& /dev/null
      mv g94.out ${i}.g94out >>& /dev/null
      mv g94.inp.1 ${i}.g94inp >>& /dev/null
      mv g98.out ${i}.g98out >>& /dev/null
      mv g98.inp.1 ${i}.g98inp >>& /dev/null
      mv Test.FChk ${i}.fchk >>& /dev/null
      rm g94.inp.* g94.out.* >>& /dev/null
      rm g98.inp.* g98.out.* Test.FChk.* >>& /dev/null
      rm ml.inp >>& /dev/null
   end

   rm $wrkdir/g98shuttle  >>& /dev/null
   rm $wrkdir/g94shuttle  >>& /dev/null

   rm $wrkdir/*.gbs  >>& /dev/null

#
#  End of script
#
