c
c******************************************************************************
c  MLHHOOK
c******************************************************************************
c
      subroutine mlhhook(progrms, geom, mcinp, mgswit, hfmoinp, mcoptl,
     *   sacinp, mcsinp, ibinp, mcoinp, mnminp, mutinp, g2inp, mg2inp, 
     *   g3inp, mg3inp, mqcinp, mcomp2inp,mccoinp,g3sxmp3inp,mc3bbinp,  0712BL02
     *   mc3mpwinp,limohc, imohcinp, ltest, tmeth, tbas, toptl, ierr)
c  
c     Subroutine mlhhook
c
c     Created:  July 9, 1999 by J. M. Rodgers
c     Revised:  January 11, 2000 by P. L. Fast
c     Purpose:  To call the appropriate hessian subhook
c
c     Called by:  main
c     Calls:  hfmohhk, mchhk, imohchhk, g2hhk, g3hhk, mg2hhk, mg3hhk, 
c             mqchhk, mcomp2hhk, mccohhk, mc3bbhhk,g3sxmp3hhk  
c
c    Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mctype, mgtype, hfmoinf, mcinf,
     *                   ginf, mginf, imoinf, proglist, mlinp
      use files, only : outfile
      use optimize, only : ener, grad, hess
      use param, only : pmco, pmnm, pmut, pib, psac, pmcs, 
     *       lowhs, uniths
      use caltyp, only : thess
      use energy
      use gradient
      use hessian

      implicit none

c
      type (proglist) :: progrms
      integer ierr, limohc, ltest, n3tm
      character*10       prognme
      type (cartgeom) :: geom
      type (mctype)   :: mcinp
      type (mgtype)   :: mgswit
      type (hfmoinf)  :: hfmoinp
      character*80    :: mcoptl(5), toptl(5)
      character*20    :: tmeth, tbas
      type (mcinf)    :: sacinp, mcsinp, ibinp, mcoinp, mnminp, mutinp   
      type (ginf)     :: g2inp, g3inp
      type (mginf)    :: mg2inp, mg3inp, mqcinp, mc3mpwinp,             0111PF00
     *                   mcomp2inp, mccoinp, g3sxmp3inp, mc3bbinp       0712BL02
      type (imoinf)   :: imohcinp
      integer         :: lmg2, lmg3

      n3tm = 3*geom%natoms
      lmg2 = 0
      lmg3 = 0
c
c  Make calls to subhooks depending on activated switches
c
c  TEST
c
      if (ltest.eq.1)  then
         call proghhk(progrms%testprog,tmeth,tbas, geom , toptl, ener, 
     *          grad(:n3tm), hess(:n3tm,:n3tm), ierr,'null')
         ener = ener + eso + ecc + erel
c
         call testdisp( geom%natoms, thess )
      endif
c
c  IMOHC
c
      if (limohc .eq. 1) then

         call imohchhk(progrms%imohlprog, progrms%imollprog, geom, 
     *           imohcinp, ierr)
      endif
c     
c  HFMO
c
      if (hfmoinp%lhfmo .eq. 1) then
         call hfmohhk(progrms%hfprog, progrms%moprog, geom, 
     *           hfmoinp, ierr)
         ener = hfmoener(3)
         grad(:n3tm) = hfmograd(3,:n3tm)
         hess(:n3tm,:n3tm) = hfmohess(3,:n3tm,:n3tm) 
      endif
c
c  SAC, MCSAC, IB, or MCCM
c     
       if (mcinp%lcoop.eq.1)  then
         if (mcinp%lib.eq.1 .or. mcinp%lsac.eq.1
     *          .or. mcinp%lmcsac.eq.1 .or. mcinp%lmccmco.eq.1
     *          .or. mcinp%lmccmnm.eq.1 .or. mcinp%lmccmut.eq.1) then
            call mchhk(progrms%mcprog, geom, mcinp, mcoptl, sacinp,
     *                mcsinp, ibinp, mcoinp, mnminp, mutinp, ierr)
         endif
      else
         if (mcinp%lmccmco.eq.1) then
            call mcohhk(progrms%mcprog,geom,mcoinp,mcoptl)
            ener = mcener(pmco)
            grad(:n3tm) = mcgrad(pmco,:n3tm)
            hess(:n3tm,:n3tm) = mchess(pmco,:n3tm,:n3tm)
         endif
         if (mcinp%lmccmnm.eq.1) then
            call mnmhhk(progrms%mcprog,geom,mnminp,mcoptl)
            ener = mcener(pmnm)
            grad(:n3tm) = mcgrad(pmnm,:n3tm)
            hess(:n3tm,:n3tm) = mchess(pmnm,:n3tm,:n3tm)
         endif
         if (mcinp%lmccmut.eq.1) then
            call muthhk(progrms%mcprog,geom,mutinp,mcoptl)
            ener = mcener(pmut)
            grad(:n3tm) = mcgrad(pmut,:n3tm)
            hess(:n3tm,:n3tm) = mchess(pmut,:n3tm,:n3tm) 
            endif
         if (mcinp%lib.eq.1) then
            call ibhhk(progrms%mcprog,geom,ibinp,mcoptl)
            ener = mcener(pib)
            grad(:n3tm) = mcgrad(pib,:n3tm)
            hess(:n3tm,:n3tm) = mchess(pib,:n3tm,:n3tm)
            endif
         if (mcinp%lmcsac.eq.1) then
            call mcshhk(progrms%mcprog,geom,mcsinp,mcoptl)
            ener = mcener(pmcs)
            grad(:n3tm) = mcgrad(pmcs,:n3tm)
            hess(:n3tm,:n3tm) = mchess(pmcs,:n3tm,:n3tm)
         endif
         if (mcinp%lsac.eq.1) then
            call sachhk(progrms%mcprog,geom,sacinp,mcoptl)
            ener = mcener(psac)
            grad(:n3tm) = mcgrad(psac,:n3tm)
            hess(:n3tm,:n3tm) = mchess(psac,:n3tm,:n3tm)
            endif
      endif   
c
c  MCG2
c
      if (mgswit%lmcg2.eq.1) then
         call mg2hhk(progrms%g2prog,geom,mg2inp,ierr)
         lmg2 = 1
         ener = mg2ener
         grad(:n3tm) = mg2grad(:n3tm)
         hess(:n3tm,:n3tm) = mg2hess(:n3tm,:n3tm)
      endif
c
c  G2
c
      if (mgswit%lg2.eq.1) then
         call g2hhk(progrms%g2prog,geom,lmg2,g2inp,ierr)
         ener = g2ener
         grad(:n3tm) = g2grad(:n3tm)
         hess(:n3tm,:n3tm) = g2hess(:n3tm,:n3tm)
      endif
c
c  MCG3
c
      if (mgswit%lmcg3.eq.1) then
         call mg3hhk(progrms%g3prog,geom,mg3inp,ierr)
         lmg3 = 1
         ener = mg3ener
         grad(:n3tm) = mg3grad(:n3tm)
         hess(:n3tm,:n3tm) = mg3hess(:n3tm,:n3tm)
      endif
c
c  MC-QCISD
c
      if (mgswit%lmqcisd.eq.1) then                                     0111PF00
         call mqchhk(progrms%g3prog,geom,lmg3,mqcinp,ierr)              0111PF00
         ener = mqcener                                                 0112PF00
         grad(:n3tm) = mqcgrad(:n3tm)                                   0112PF00
         hess(:n3tm,:n3tm) = mqchess(:n3tm,:n3tm)                       0112PF00
      endif                                                             0111PF00
c
c  MCOMP2
c
      if (mgswit%lmcomp2.eq.1) then                                     0710PJ00
         call mcomp2hhk(progrms%g3prog,geom,lmg3,mcomp2inp,ierr)        0710PJ00
         ener = mcomp2ener                                              0710PJ00
         grad(:n3tm) = mcomp2grad(:n3tm)                                0710PJ00
         hess(:n3tm,:n3tm) = mcomp2hess(:n3tm,:n3tm)                    0710PJ00
      endif                                                             0710PJ00

c
c  MCCO
c
      if (mgswit%lmcco.eq.1) then                                       0712BL02
         call mccohhk(progrms%g3prog,geom,lmg3,mccoinp,ierr)            0712BL02
         ener = mccoener                                                0713BL02
         grad(:n3tm) = mccograd(:n3tm)                                  0713BL02
         hess(:n3tm,:n3tm) = mccohess(:n3tm,:n3tm)                      0713BL02
      endif                                                             0712BL02

c
c  MC3BB
c
      if (mgswit%lmc3bb.eq.1) then                                      1220YZ03 
         call mc3bbhhk(progrms%g3prog,geom,lmg3,mc3bbinp,ierr)          1220YZ03 
         ener = mc3bbener                                               1220YZ03 
         grad(:n3tm) = mc3bbgrad(:n3tm)                                 1220YZ03
         hess(:n3tm,:n3tm) = mc3bbhess(:n3tm,:n3tm)                     1220YZ03
      endif                                                             1220YZ03

c
c  MC3MPW
c
      if (mgswit%lmc3mpw.eq.1) then                                     1220YZ03
         call mc3mpwhhk(progrms%g3prog,geom,lmg3,mc3mpwinp,ierr)        1220YZ03
         ener = mc3mpwener                                              1220YZ03
         grad(:n3tm) = mc3mpwgrad(:n3tm)                                1220YZ03
         hess(:n3tm,:n3tm) = mc3mpwhess(:n3tm,:n3tm)                    1220YZ03
      endif                                                             1220YZ03


c
c  G3SX(MP3) 
c
      if (mgswit%lg3sxmp3.eq.1) then                                    1220YZ03

       call g3sxmp3hhk(progrms%g3prog,geom,lmg3,g3sxmp3inp,ierr)        1220YZ03

       ener = g3sxmp3ener                                               1220YZ03

       grad(:n3tm) = g3sxmp3grad(:n3tm)                                 1220YZ03
       hess(:n3tm,:n3tm) = g3sxmp3hess(:n3tm,:n3tm)                     1220YZ03
      endif                                                             1220YZ03

c
c  G3
c
      if (mgswit%lg3.eq.1) then
         call g3hhk(progrms%g3prog,geom,lmg3,g3inp,ierr)                0111PF00
         ener = g3ener
         grad(:n3tm) = g3grad(:n3tm)
         hess(:n3tm,:n3tm) = g3hess(:n3tm,:n3tm)
      endif

c
c   Frequency calculation
c
      call freqcal(geom)                                                0910YZ03

      return
      end
c
c     
c******************************************************************************
c MCHHK
c******************************************************************************
c
      subroutine mchhk(prognme, geom, mcinp, mcoptl, sacinp,
     *                   mcsinp, ibinp, mcoinp, mnminp, mutinp, ierr)
c
c     Subroutine mchhk
c
c     Created:  July 9, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To determine all necessary electronic structure
c       calculations, make calls to the e.s. program, and then carry out
c       the SAC, MCSAC, IB, and MCCM hessian calculations
c
c     Called by:  mlhhook  
c     Calls:  mcchk, mcochk, mnmchk, mutchk, mcschk, ibchk, sacchk,
c             getemco, getemnm, getemut, geteib, getemcs, getesac,
c             getgmco, getgmnm, getgmut, getgib, getgmcs, getgsac,
c             gethmco, gethmnm, gethmut, gethib, gethmcs, gethsac,
c             mcdisp, setmcsw, eshparse
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mctype, mcinf
      use param
      use files
      use energy
      use gradient
      use hessian
      implicit none

      type (cartgeom) :: geom
      type (mctype)   :: mcinp
      character*80    :: mcoptl(5)
      type (mcinf)    :: sacinp, mcsinp, ibinp, mcoinp, mnminp, mutinp
c
c  Note - esswit will indicate which electronic structure calls to make to
c    the exterior program, and mcswit will indicate which MC calculations
c    to do with the obtained information.  The integers used to indicate
c    this are all defined in the module param.
c
      integer esswit(numes,numbas), mcswit(5,numcalc)
      integer ierr, i, j, k, l, ctr, natoms, max, vers
      integer mcmeth, coefsw, esmeth, basis
      double precision coef(10)
      character*10  prognme
c
c  Initialize switches to 0 and energies/grad/hess to 0.0000d0
c
      do 20 i=1, numes
         do 40 j=1, numbas
            esswit(i,j) = 0
            esener(i,j) = 0.0000d0
            do 50 k=1, 3*geom%natoms
               esgrad(i,j,k) = 0.0000d0
               do 55 l=1, 3*geom%natoms
                  eshess(i,j,k,l) = 0.0000d0
  55           continue
  50        continue
  40     continue
  20  continue
c
      do 60 i=1, 5
         do 80 j=1,numcalc
            mcswit(i,j) = 0
  80     continue
  60  continue
      do 100 i=1, numcalc
         mcener(i) = 0.0000d0
         do 90 j=1, 3*geom%natoms
            mcgrad(i,j) = 0.0000d0
            do 95 k=1, 3*geom%natoms
               mchess(i,j,k) = 0.0000d0
  95        continue
  90     continue
 100  continue
c
c  Initialize counter of mc calcs (ctr) to 0.
c
      ctr = 0
c
c  Pass esswit and mcswit to checking subroutines to determine which
c    es and mc calculations are necessary if standard methods and bases
c    have been specified.  If non-standard choices are selected, another
c    hook is called which does not attempt to make all possible mc
c    calculations.
c  Currently non-standard bases are supported for MCCM, IB, MCSAC, and SAC.
c  Non-standard methods are supported for IB and SAC.
c     
      if (mcinp%lmccmco .eq. 1) then
         if (mcoinp%stdm.eq.1 .and. mcoinp%stdb1.eq.1 
     *        .and. mcoinp%stdb2.eq.1) then        
            call mcochk( mcoinp%meth, esswit, mcswit, ctr, ierr )
         else
            call setmcsw( mcswit, ctr, pmco, nodef, nstd, nstd )
            call mcohhk(prognme,geom,mcoinp,mcoptl)
         endif
      endif
      if (mcinp%lmccmnm .eq. 1) then
         if (mnminp%stdm.eq.1 .and. mnminp%stdb1.eq.1 
     *        .and. mnminp%stdb2.eq.1 .and. mnminp%stdb3.eq.1) then
            call mnmchk( mnminp%meth, esswit, mcswit, ctr, ierr )
         else
            call setmcsw( mcswit, ctr, pmnm, nodef, nstd, nstd )
            call mnmhhk(prognme,geom,mnminp,mcoptl)
         endif
      endif
      if (mcinp%lmccmut .eq. 1) then
         if (mutinp%stdm.eq.1 .and. mutinp%stdb1.eq.1 
     *        .and. mutinp%stdb2.eq.1) then
            call mutchk( mutinp%meth, esswit, mcswit, ctr, ierr )
         else
            call setmcsw( mcswit, ctr, pmut, nodef, nstd, nstd )
            call muthhk(prognme,geom,mutinp,mcoptl)
         endif
      endif
      if (mcinp%lib .eq. 1) then
         if (ibinp%stdm.eq.1 .and. ibinp%stdb1.eq.1 
     *        .and. ibinp%stdb2.eq.1) then
            call ibchk(ibinp%meth,esswit,mcswit,ctr,ierr)
         else
            call setmcsw( mcswit, ctr, pib, nodef, nstd, nstd )
            call ibhhk(prognme,geom,ibinp,mcoptl)
         endif
      endif
      if (mcinp%lmcsac .eq. 1) then
         if (mcsinp%stdm.eq.1 .and. mcsinp%stdb1.eq.1) then
            call mcschk(mcsinp%meth,mcsinp%bas1,esswit,mcswit,ctr,ierr)        
         else
            call setmcsw( mcswit, ctr, pmcs, nodef, nstd, nstd )
            call mcshhk(prognme,geom,mcsinp,mcoptl)
         endif
      endif
      if (mcinp%lsac .eq. 1) then
         if (sacinp%stdm.eq.1 .and. sacinp%stdb1.eq.1) then
            call sacchk(sacinp%meth,sacinp%bas1,esswit,mcswit,ctr,ierr)
         else
            call setmcsw( mcswit, ctr, psac, nodef, nstd, nstd )
            call sachhk(prognme,geom,sacinp,mcoptl)
         endif
      endif
c
c  From esswit, set all default MC calculation in mcswit.
c
      call mcchk( esswit, mcswit, ctr )
c
c  Make all electronic structure calls recorded in esswit with eshparse.
c  Then parse out mcswit and for all standard mc calculations pass info on
c    to a function that will gather the necessary electronic structure
c    information and pass these off to appropriate calculation functions 
c  All nonstandard energy calculations will already have been carried out
c    by the individual hooks.
c
      if (ctr .gt. 0) then
         call eshparse( prognme, geom, mcoptl, esswit, ierr )
         i = 1
         do while (i.le.(ctr+nummc))
            if (mcswit(3,i).eq.nstd .or. mcswit(4,i).eq.nstd .or.
     *             mcswit(1,i).eq.0) then
               mcswit(5,i) = 0
               i = i+1
            else
               mcmeth = mcswit(1,i)
               coefsw = mcswit(2,i)
               esmeth = mcswit(3,i)  
               basis = mcswit(4,i)
               natoms = geom%natoms
               if (mcmeth .eq. pmco) then
                  if (mcoinp%version(:4) .eq. 'v1sc') then
                     vers = v1sc
                     mcswit(5,i) = v1sc
                  elseif (mcoinp%version(:4) .eq. 'v2sc') then
                     vers = v2sc
                     mcswit(5,i) = v2sc
                  elseif (mcoinp%version(:3) .eq. 'v2s') then
                     vers = v2s
                     mcswit(5,i) = v2s
                  elseif (mcoinp%version(:3) .eq. 'v2m') then
                     vers = v2m
                     mcswit(5,i) = v2m
                  end if
                  coef = mcoinp%coef
                  call getemco(i, coefsw, coef, esmeth, vers)
                  call getgmco(i, coefsw, coef, esmeth, vers, natoms)
                  call gethmco(i, coefsw, coef, esmeth, vers, natoms)
               elseif (mcmeth .eq. pmnm) then
                  if (mnminp%version(:4) .eq. 'v1sc') then
                     vers = v1sc
                     mcswit(5,i) = v1sc
                  elseif (mnminp%version(:4) .eq. 'v2sc') then
                     vers = v2sc
                     mcswit(5,i) = v2sc
                  elseif (mnminp%version(:3) .eq. 'v2s') then
                     vers = v2s
                     mcswit(5,i) = v2s
                  elseif (mnminp%version(:3) .eq. 'v2m') then
                     vers = v2m
                     mcswit(5,i) = v2m
                  end if
                  coef = mnminp%coef
                  call getemnm(i, coefsw, coef, esmeth, vers)
                  call getgmnm(i, coefsw, coef, esmeth, vers, natoms)
                  call gethmnm(i, coefsw, coef, esmeth, vers, natoms)
               elseif (mcmeth .eq. pmut) then
                  if (mutinp%version(:4) .eq. 'v1sc') then
                     vers = v1sc
                     mcswit(5,i) = v1sc
                  elseif (mutinp%version(:4) .eq. 'v2sc') then
                     vers = v2sc
                     mcswit(5,i) = v2sc
                  elseif (mutinp%version(:3) .eq. 'v2s') then
                     vers = v2s
                     mcswit(5,i) = v2s
                  elseif (mutinp%version(:3) .eq. 'v2m') then
                     vers = v2m
                     mcswit(5,i) = v2m
                  end if
                  coef = mutinp%coef
                  call getemut(i, coefsw, coef, esmeth, vers)
                  call getgmut(i, coefsw, coef, esmeth, vers, natoms)
                  call gethmut(i, coefsw, coef, esmeth, vers, natoms)
               elseif (mcmeth .eq. pmcs) then
                  if (mcsinp%version(:4) .eq. 'v1sc') then
                     vers = v1sc
                     mcswit(5,i) = v1sc
                  elseif (mcsinp%version(:4) .eq. 'v2sc') then
                     vers = v2sc
                     mcswit(5,i) = v2sc
                  elseif (mcsinp%version(:3) .eq. 'v2s') then
                     vers = v2s
                     mcswit(5,i) = v2s
                  elseif (mcsinp%version(:3) .eq. 'v2m') then
                     vers = v2m
                     mcswit(5,i) = v2m
                  end if
                  coef = mcsinp%coef
                  call getemcs(i, coefsw, coef, esmeth, vers, basis)
                  call getgmcs(i, coefsw, coef, esmeth, vers, 
     *                         basis, natoms)
                  call gethmcs(i, coefsw, coef, esmeth, vers, 
     *                         basis, natoms)
               elseif (mcmeth .eq. pib) then
                  mcswit(5,i) = 0
                  coef = ibinp%coef
                  call geteib(i, coefsw, coef, esmeth)
                  call getgib(i, coefsw, coef, esmeth, natoms)
                  call gethib(i, coefsw, coef, esmeth, natoms)
               elseif (mcmeth .eq. psac) then
                  if (sacinp%version(:4) .eq. 'v1sc') then
                     vers = v1sc
                     mcswit(5,i) = v1sc
                  elseif (sacinp%version(:3) .eq. 'v1s') then
                     vers = v1s
                     mcswit(5,i) = v1s
                  elseif (sacinp%version(:4) .eq. 'v2sc') then
                     vers = v2sc
                     mcswit(5,i) = v2sc
                  elseif (sacinp%version(:3) .eq. 'v2s') then
                     vers = v2s
                     mcswit(5,i) = v2s
                  elseif (sacinp%version(:3) .eq. 'v2m') then
                     vers = v2m
                     mcswit(5,i) = v2m
                  elseif (sacinp%version(:3) .eq. 'v3m') then
                     vers = v3m
                     mcswit(5,i) = v3m
                  elseif (sacinp%version(:3) .eq. 'v3s') then
                     vers = v3s
                     mcswit(5,i) = v3s
                  end if
                  coef = sacinp%coef
                  call getesac(i, coefsw, coef, esmeth, vers, basis)
                  call getgsac(i, coefsw, coef, esmeth, vers, 
     *                         basis, natoms)
                  call gethsac(i, coefsw, coef, esmeth, vers, 
     *                         basis, natoms)
               endif
c
c  Add on ESO and ECC and EREL
c
               mcener(i) = mcener(i) + eso + ecc + erel
               i = i+1
            endif
         enddo
      endif

      call mcdisp( prognme, esswit, mcswit, ctr, natoms, thess )

      return 
      end
c
c
c******************************************************************************
c  ESHPARSE
c******************************************************************************
c     
      subroutine eshparse( prognme, geom, optl, esswit, ierr )
c
c     Subroutine eshparse
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Parse esswit and for each electronic structure calculation
c
c     Called by:  mchhk
c     Calls:  proghhk
c
c     Variables defined here:
c
      use input, only : cartgeom
      use param, only : esmlist, baslist, numes, numbas
      use files, only : outfile
      use energy, only : esener
      use gradient, only : esgrad
      use hessian, only : eshess
      implicit none
      
      type (cartgeom) :: geom
      character*10 prognme
      character*20 esmeth
      character*20 esbas
      character*80 optl(5)

      double precision ener, grad(3*geom%natoms)
      double precision hess(3*geom%natoms, 3*geom%natoms)
      integer esswit(numes,numbas), ierr

      integer i, j, k

      ierr = 0
      i = 1

      do while (i.le.numes .and. ierr.eq.0)
         j = 1
         do while (j.le.numbas .and. ierr.eq.0)
            if (esswit(i,j).eq.1 .and. ierr.eq.0) then
               esmeth = '                    '
               esbas =  '                    '
               esmeth = esmlist(i)
               esbas = baslist(j)
               call proghhk(prognme, esmeth, esbas, geom, optl,
     *                         ener, grad, hess, ierr,'null')
               if (ierr .ne. 1) then
                  esener(i,j) = ener
                  esgrad(i,j,:3*geom%natoms) = grad
                  eshess(i,j,:3*geom%natoms,:3*geom%natoms) = hess
               endif
            endif
            j = j+1
         end do
         i = i+1
      end do

      if (ierr.eq.1) then
         write (outfile,*) 'ERROR calling electronic structure program'        
         stop 'eshparse 1'
      endif

      return
      end
c
c
c******************************************************************************
c  GETHMCO
c******************************************************************************
c
      subroutine gethmco(index, coefsw, inpcoef, esmeth, vers, natoms)
c
c     Subroutine gethmco
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Looks at MCCM-CO calculation requested, gets the
c        necessary electronic structure information from eshess 
c        and passes it off to calmco to calculate the hessian.
c
c     Called by:  mchhk
c     Calls:  calmco
c
c     Variables defined here:
c
      use param
      use hessian, only : eshess, mchess
      implicit none

      integer i, j, k, index, coefsw, esmeth, basis, max, natoms, vers
      double precision inpcoef(10), coef(10)
      double precision mcoeshs(5,2,3*natoms,3*natoms)

c
c  Set electronic structure gradient arrays to 0.0000d0
c
      do 20 i=1, 5
         do 30 j=1, 3*natoms
            do 35 k=1, 3*natoms
               mcoeshs(i,1,j,k) = 0.0000d0
               mcoeshs(i,2,j,k) = 0.0000d0
  35        continue
  30     continue
  20  continue
c
c  Gather MCCM-CO electronic structure info in mcoeshs
c
      mcoeshs(1,1,:,:) = eshess(phf,pdz,:3*natoms,:3*natoms) 
      mcoeshs(1,2,:,:) = eshess(phf,ptz,:3*natoms,:3*natoms) 
      mcoeshs(2,1,:,:) = eshess(pmp2,pdz,:3*natoms,:3*natoms)
      mcoeshs(2,2,:,:) = eshess(pmp2,ptz,:3*natoms,:3*natoms)
      if (esmeth.eq.pccsd .or. esmeth.eq.pccsdt) then
         mcoeshs(3,1,:,:) = eshess(pccsd,pdz,:3*natoms,:3*natoms)
         mcoeshs(3,2,:,:) = eshess(pccsd,ptz,:3*natoms,:3*natoms)
      endif
      if (esmeth.eq.pccsdt) then
         mcoeshs(4,1,:,:) = eshess(pccsdt,pdz,:3*natoms,:3*natoms)
         mcoeshs(4,2,:,:) = eshess(pccsdt,ptz,:3*natoms,:3*natoms)
      endif
      if (esmeth.eq.pmp4sdq .or. esmeth.eq.pmp4) then
         mcoeshs(3,1,:,:) = eshess(pmp4sdq,pdz,:3*natoms,:3*natoms)
         mcoeshs(3,2,:,:) = eshess(pmp4sdq,ptz,:3*natoms,:3*natoms)
      endif
      if (esmeth.eq.pmp4) then
         mcoeshs(4,1,:,:) = eshess(pmp4,pdz,:3*natoms,:3*natoms)
         mcoeshs(4,2,:,:) = eshess(pmp4,ptz,:3*natoms,:3*natoms)
      endif
c
c  Based on the electronic structure series that the given calculation is
c    in, determine the number of differences to be taken.
c
      if (esmeth.eq.pmp2)     max=2
      if (esmeth.eq.pmp4sdq)  max=3
      if (esmeth.eq.pmp4)     max=4
      if (esmeth.eq.pccsd)    max=3
      if (esmeth.eq.pccsdt)   max=4
c
c  Look at coefsw and depending on whether default or non-default
c    coefficients have been requested, pass on to calmco either the input
c    coefficients (inpcoef) or the default coefficients from module param
c
      do 40 i=1, 10
         coef(i) = 0.0000d0
  40  continue
      
      if (coefsw.eq.def) then
         coef = mcodefc(vers, esmeth, :10)
      elseif (coefsw.eq.nodef) then
         coef = inpcoef(:10)
      endif
c
c  Call calmco to calculate the MCCM-CO hessian based on the e.s.
c    information and the given coefficients.
c
      do 60 j=1, 3*natoms
         do 80 k=1, j
            call calmco( mchess(index,j,k), coef, mcoeshs(:,:,j,k),
     *                     max, natoms )
            if (k.ne.j)  mchess(index,k,j) = mchess(index,j,k)
  80     continue
  60  continue

      return
      end
c
c******************************************************************************
c  GETHMNM
c******************************************************************************
c
      subroutine gethmnm(index, coefsw, inpcoef, esmeth, vers, natoms)
c
c     Subroutine gethmnm
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Look at MCCM-NM calculation requested, gather the
c        necessary electronic structure information from eshess 
c        and pass it off to calmnm to calculate the hessian.
c
c     Called by:  mchhk
c     Calls:  calmnm
c
c     Variables defined here:
c
      use param
      use hessian, only : eshess, mchess
      implicit none

      integer i, j, k, index, coefsw, esmeth, basis, max, natoms, vers
      double precision inpcoef(10), coef(7)
      double precision mnmeshs(5,3,3*natoms,3*natoms)

c
c  Set electronic structure gradient arrays to 0.0000d0
c
      do 20 i=1, 5
         do 30 j=1, 3*natoms
            do 40 k=1, 3*natoms
               mnmeshs(i,1,j,k) = 0.0000d0
               mnmeshs(i,2,j,k) = 0.0000d0
               mnmeshs(i,3,j,k) = 0.0000d0
  40        continue
  30     continue
  20  continue
c
c  Gather MCCM-NM electronic structure info in mnmeshs
c
      mnmeshs(1,1,:,:) = eshess(phf,pdz,:3*natoms,:3*natoms)
      mnmeshs(1,2,:,:) = eshess(phf,ptz,:3*natoms,:3*natoms)
c      mnmeshs(1,3,:,:) = eshess(phf,pdzs,:3*natoms,:3*natoms)
      mnmeshs(1,3,:,:) = eshess(phf,mpdz,:3*natoms,:3*natoms)           0808RMP12
      mnmeshs(2,1,:,:) = eshess(pmp2,pdz,:3*natoms,:3*natoms)
      mnmeshs(2,2,:,:) = eshess(pmp2,ptz,:3*natoms,:3*natoms)
      mnmeshs(3,1,:,:) = eshess(pccsd,pdz,:3*natoms,:3*natoms)
      mnmeshs(4,1,:,:) = eshess(pccsdt,pdz,:3*natoms,:3*natoms)
c
c  Based on the electronic structure series that the given calculation is
c    in, determine the number of differences to be taken.
c
      if (esmeth.eq.pccsdt)   max=4
c
c  Look at coefsw and depending on whether default or non-default
c    coefficients have been requested, pass on to calmnm either the input
c    coefficients (inpcoef) or the default coefficients from param.inc 
c
      do 50 i=1, 7
         coef(i) = 0.0000d0
  50  continue
      
      if (coefsw.eq.def) then
         coef = mnmdefc(vers, :7)
      elseif (coefsw.eq.nodef) then
         coef = inpcoef(:7)
      endif
c
c  Call calmnm to calculate the MCCM-NM hessian.
c
      do 60 j=1, 3*natoms
         do 80 k=1, j
            call calmnm( mchess(index,j,k), coef, mnmeshs(:,:,j,k),
     *                    max, natoms)
            if (k.ne.j)  mchess(index,k,j) = mchess(index,j,k)
  80     continue
  60  continue

      return
      end
c
c******************************************************************************
c  GETHMUT
c******************************************************************************
c
      subroutine gethmut(index, coefsw, inpcoef, esmeth, vers, natoms)
c
c     Subroutine gethmut
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Looks at MCCM-UT calculation requested, gets the
c        necessary electronic structure information from eshess 
c        and passes it off to calmut to calculate the hessian.
c
c     Called by:  mchhk
c     Calls:  calmut
c
c     Variables defined here:
c
      use param
      use hessian, only : eshess, mchess
      implicit none

      integer i, j, k, index, coefsw, esmeth, basis, max, natoms, vers
      double precision inpcoef(10), coef(7)
      double precision muteshs(5,2,3*natoms,3*natoms)

c
c  Set electronic structure gradient array to 0.0000d0
c
      do 20 i=1, 5
         do 30 j=1, 3*natoms
            do 35 k=1, 3*natoms
               muteshs(i,1,j,k) = 0.0000d0
               muteshs(i,2,j,k) = 0.0000d0
  35        continue
  30     continue
  20  continue
c
c  Gather MCCM-UT electronic structure info
c
      muteshs(1,1,:,:) = eshess(phf,pdz,:3*natoms,:3*natoms)
      muteshs(1,2,:,:) = eshess(phf,ptz,:3*natoms,:3*natoms)
      muteshs(2,1,:,:) = eshess(pmp2,pdz,:3*natoms,:3*natoms)
      muteshs(2,2,:,:) = eshess(pmp2,ptz,:3*natoms,:3*natoms)
      if (esmeth.eq.pccsd .or. esmeth.eq.pccsdt) then
         muteshs(3,1,:,:) = eshess(pccsd,pdz,:3*natoms,:3*natoms)
      endif
      if (esmeth.eq.pccsdt) then
         muteshs(4,1,:,:) = eshess(pccsdt,pdz,:3*natoms,:3*natoms)
      endif
      if (esmeth.eq.pmp4sdq .or. esmeth.eq.pmp4) then
         muteshs(3,1,:,:) = eshess(pmp4sdq,pdz,:3*natoms,:3*natoms)
      endif
      if (esmeth.eq.pmp4) then
         muteshs(4,1,:,:) = eshess(pmp4,pdz,:3*natoms,:3*natoms)
      endif
c
c  Based on the electronic structure series that the given calculation is
c    in, determine the number of differences to be taken.
c
      if (esmeth.eq.pmp4sdq)  max=3
      if (esmeth.eq.pmp4)     max=4
      if (esmeth.eq.pccsd)    max=3
      if (esmeth.eq.pccsdt)   max=4
c
c  Look at coefsw and depending on whether default or non-default
c    coefficients have been requested, pass on to calmut either the input
c    coefficients (inpcoef) or the default coefficients from param.inc 
c
      do 40 i=1, 7
         coef(i) = 0.0000d0
  40  continue
      
      if (coefsw.eq.def) then
         coef = mutdefc(vers, esmeth, :7)
      elseif (coefsw.eq.nodef) then
         coef = inpcoef(:7)
      endif
c
c  Call calmut to calculate the MCCM-UT hessian based on the e.s.
c    information and the given coefficients.
c
      do 60 j=1, 3*natoms
         do 80 k=1, j
            call calmut( mchess(index,j,k), coef, muteshs(:,:,j,k),
     *                    max, natoms)
            if (k.ne.j)  mchess(index,k,j) = mchess(index,j,k)
  80     continue
  60  continue

      return
      end
c
c******************************************************************************
c  GETHIB
c******************************************************************************
c
      subroutine gethib(index, coefsw, inpcoef, esmeth, natoms)
c
c     Subroutine gethib
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Looks at IB calculation requested, gets the
c        necessary electronic structure information from eshess and pass
c        it off to calib to calculate the hessian.
c
c     Called by:  mchhk
c     Calls:  calib
c
c     Variables defined here:
c
      use param
      use hessian, only : eshess, mchess
      implicit none

      integer i, j, k, index, coefsw, esmeth, basis, max, natoms
      double precision inpcoef(10), alpha, beta
      double precision ibeshs(2,2,3*natoms,3*natoms)

c
c  Set electronic structure energy arrays to 0.0000d0
c
      do 20 j=1, 3*natoms
         do 25 k=1, 3*natoms
            ibeshs(1,1,j,k) = 0.0000d0
            ibeshs(2,1,j,k) = 0.0000d0
            ibeshs(1,2,j,k) = 0.0000d0
            ibeshs(2,2,j,k) = 0.0000d0 
  25     continue
  20  continue
c
c  Gather IB electronic structure info in ibes
c
      ibeshs(1,1,:,:) = eshess(phf,pdz,:3*natoms,:3*natoms)
      ibeshs(1,2,:,:) = eshess(phf,ptz,:3*natoms,:3*natoms)
      ibeshs(2,1,:,:) = eshess(esmeth,pdz,:3*natoms,:3*natoms)
      ibeshs(2,2,:,:) = eshess(esmeth,ptz,:3*natoms,:3*natoms)
c
c  Look at coefsw and depending on whether default or non-default
c    coefficients have been requested, pass on to calib either the input
c    coefficients (inpcoef) or the default coefficients from param.inc 
c
      alpha = 0.0000d0
      beta = 0.0000d0
      
      if (coefsw.eq.def) then
         alpha = ibdefa
         beta = ibdefb(esmeth)
      elseif (coefsw.eq.nodef) then
         alpha = inpcoef(1)
         beta = inpcoef(2)
      endif
c
c  Call calib to calculate the IB hessian based on the e.s.
c    information and the given coefficients.
c
      do 60 j=1, 3*natoms
         do 80 k=1, j
c
c  Commented by Jingzhi Pu, incorrect number of parameter in this       0418PJ01
c  call at Multilevel 2.2 and early versions                            0418PJ01
c   
c
c           call calib( mchess(index,j,k), alpha, beta,
c    *                   ibeshs(:,:,j,k), natoms)
c 

            call calib( mchess(index,j,k),alpha, beta,                  0418PJ01
     *                   ibeshs(:,:,j,k) )                              0418PJ01

            if (k.ne.j)  mchess(index,k,j) = mchess(index,j,k)
  80     continue
  60  continue

      return
      end
c
c******************************************************************************
c  GETHMCS
c******************************************************************************
c
      subroutine gethmcs(index, coefsw, inpcoef, esmeth, vers, 
     *                   basis, natoms)
c
c     Subroutine gethmcs
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Looks at MCSAC calculation requested, gets the
c        necessary electronic structure information from eshess and pass
c        it off to calmcs to calculate the hessian.
c
c     Called by:  mchhk
c     Calls:  calmcs
c
c     Variables defined here:
c
      use param
      use hessian, only : eshess, mchess
      implicit none

      integer i, j, k, index, coefsw, esmeth, basis, max, natoms, vers
      double precision inpcoef(10), coef(4)
      double precision mcseshs(5,3*natoms,3*natoms)

c
c  Set electronic structure energy arrays to 0.0000d0
c
      do 20 i=1, 5
         do 30 j=1, 3*natoms
            do 35 k=1, 3*natoms
               mcseshs(i,j,k) = 0.0000d0
  35        continue
  30     continue
  20  continue
c
c  Gather MCSAC info and pass to calmcs
c
      mcseshs(1,:,:) = eshess(phf, basis, :3*natoms, :3*natoms)
      mcseshs(2,:,:) = eshess(pmp2, basis, :3*natoms, :3*natoms)
      if (esmeth.eq.pccsd .or. esmeth.eq.pccsdt) then
         mcseshs(3,:,:) = eshess(pccsd, basis, :3*natoms, :3*natoms)
      endif
      if (esmeth.eq.pccsdt) then
         mcseshs(4,:,:) = eshess(pccsdt, basis, :3*natoms, :3*natoms)
      endif
      if (esmeth.eq.pmp4sdq .or. esmeth.eq.pmp4) then
         mcseshs(3,:,:) = eshess(pmp4sdq, basis, :3*natoms, :3*natoms)
      endif
      if (esmeth.eq.pmp4) then
         mcseshs(4,:,:) = eshess(pmp4, basis, :3*natoms, :3*natoms)
      endif
c
c  Based on the electronic structure series that the given calculation is
c    in, determine the number of differences to be taken.
c
      if (esmeth.eq.pmp4sdq)  max=3
      if (esmeth.eq.pmp4)     max=4
      if (esmeth.eq.pccsd)    max=3
      if (esmeth.eq.pccsdt)   max=4
c
c  Look at coefsw and depending on whether default or non-default
c    coefficients have been requested, pass on to calmcs either the input
c    coefficients (inpcoef) or the default coefficients from param.inc 
c
      do 40 i=1, 4
         coef(i) = 0.0000d0
  40  continue
      
      if (coefsw.eq.def) then
         coef = mcsdefc(vers, esmeth, basis, :4)
      elseif (coefsw.eq.nodef) then
         coef = inpcoef(:4)
      endif

c
c  Call calmcs to calculate the MCSAC hessian based on the e.s.
c    information and the given coefficients.
c
      do 60 j=1, 3*natoms
         do 80 k=1, j
            call calmcs( mchess(index,j,k), coef, mcseshs(:,j,k),
     *                     max, natoms)
            if (k.ne.j)  mchess(index,k,j) = mchess(index,j,k)
  80     continue
  60  continue

      return
      end
c
c******************************************************************************
c  GETHSAC
c******************************************************************************
c
      subroutine gethsac(index, coefsw, inpcoef, esmeth, vers, 
     *                   basis, natoms)
c
c     Subroutine gethsac
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Looks at SAC calculation requested, gets the
c        necessary electronic structure information from eshess and pass
c        it off to calsac to calculate the hessian.
c
c     Called by:  mchhk
c     Calls:  calsac
c
c     Variables defined here:
c
      use param
      use hessian, only : eshess, mchess
      implicit none

      integer i, j, k, index, coefsw, esmeth, basis, max, natoms, vers
      double precision inpcoef(10), coef
      double precision saceshs(2,3*natoms,3*natoms)

c
c  Set electronic structure energy arrays to 0.0000d0
c
      do 20 j=1, 3*natoms
         do 40 k=1, 3*natoms
            saceshs(1,j,k) = 0.0000d0
            saceshs(2,j,k) = 0.0000d0
  40     continue
  20  continue
c
c  Gather SAC info and pass to calsac
c
      saceshs(1,:,:) = eshess(phf, basis, :3*natoms, :3*natoms)
      saceshs(2,:,:) = eshess(esmeth, basis, :3*natoms, :3*natoms)
c
c  Look at coefsw and depending on whether default or non-default
c    coefficients have been requested, pass on to calsac either the input
c    coefficients (inpcoef) or the default coefficients from param.inc 
c
      coef = 0.0000d0

      if (coefsw.eq.def) then
         coef = sacdefc(vers,esmeth,basis)
      elseif (coefsw.eq.nodef) then
         coef = inpcoef(1)
      endif
c
c  Call calsac to calculate the SAC hessian based on the e.s.
c    information and the given coefficients.
c 
      do 60 j=1, 3*natoms
         do 80 k=1, j
            call calsac(mchess(index,j,k),coef,saceshs(:,j,k),natoms)
            if (k.ne.j)  mchess(index,k,j) = mchess(index,j,k)
  80     continue
  60  continue

      return
      end
c
c
c*****************************************************************************
c  PROGHHK
c*****************************************************************************
c
      subroutine proghhk(prognme, esmeth, esbas, geom, optl, 
     *                    ener, grad, hess, ierr, ver_lab)
c
c     Subroutine proghhk
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:  Feb 24, 2002 by B. J. Lynch
c     Purpose:  Get a single point energy, gradient, and hessian for the
c        given geom with the specified electronic structure package.
c
c     Description:  Calls a function to write a G94/98 FREQ input file,
c         runs this calculation on the system, and then calls fxns that
c         read the energy, gradient, and hessian from the formatted
c         checkpoint file created by G94/98.
c
c     Note:  Currently only G94/G98 is enabled but it would be easily
c        expanded to other electronic structure programs.  new _inpe and
c        _oute subroutines would have to be written for each different
c        program though.
c
c     Called by: hfmohhk, opthhk, imohchhk, eshparse, mcohhk, mnmhhk,
c        muthhk, mcshhk, ibhhk, sachhk, g2hhk, g3hhk, mg2hhk, mg3hhk
c     Calls:  g98inp, g98oute, mg98oute, g98outg, g98outh, system
c
c     Variables defined here:
c
      use caltyp
      use files
      use input, only : cartgeom
      implicit none

      character*10 prognme
      character*20 esmeth, esbas,ver_lab
      type (cartgeom) :: geom
      character*80 optl(5)
      double precision ener, grad(3*geom%natoms)
      double precision hess(3*geom%natoms, 3*geom%natoms)
      integer ierr


c
c  GAUSSIAN98
c
      if (prognme(:3).eq.'g98') then
         open (unit=g98inf, status='unknown', file=g98in, err=9991)
         call g98inp(g98inf,esmeth,esbas,geom,optl,thess,ver_lab)
         close (g98inf, err=9991)
         call system('./g98shuttle g98.inp g98.out')
         call g98oute(1,esmeth, ener)
         call g98outg(1,esmeth, grad, geom%natoms)
         call g98outh(esmeth, hess, geom%natoms)
c
c  GAUSSIAN94     
c    Just reuse g98inp and g98outg since formats in the FChk files have
c    remained essentially the same.
c
      elseif (prognme(:3).eq.'g94') then
         open (unit=g94inf, status='unknown', file=g94in, err=9992)
         call g98inp(g94inf, esmeth,esbas,geom,optl,thess,ver_lab)
         close (g94inf, err=9992)
         call system('./g94shuttle g94.inp g94.out')
         call g98oute(1,esmeth, ener)
         call g98outg(1,esmeth, grad, geom%natoms)
         call g98outh(esmeth, hess, geom%natoms)
c
c  GAUSSIAN03
c    Just reuse g98inp and g98outg since formats in the FChk files have
c    remained essentially the same.
c
      elseif (prognme(:3).eq.'g03') then
         open (unit=g03inf, status='unknown', file=g03in, err=9993)
         call g98inp(g03inf, esmeth,esbas,geom,optl,thess,ver_lab)
         close (g03inf, err=9993)
         call system('./g03shuttle g03.inp g03.out')
         call g98oute(1,esmeth, ener)
         call g98outg(1,esmeth, grad, geom%natoms)
         call g98outh(esmeth, hess, geom%natoms)                           1409ZY03
c
c  GAUSSIAN09
c
      elseif (prognme(:3).eq.'g09') then
         open (unit=g09inf, status='unknown', file=g09in, err=9994)
         call g98inp(g09inf, esmeth,esbas,geom,optl,thess,ver_lab)
         close (g09inf, err=9994)
         call system('./g09shuttle g09.inp g09.out')
         call g98oute(1,esmeth, ener)
         call g98outg(1,esmeth, grad, geom%natoms)
         call g98outh(esmeth, hess, geom%natoms)                           1409ZY03
      endif

      return

9991  write (outfile,*) 'Error creating Gaussian98 Freq input file'
      stop 'proghhk 1'
9992  write (outfile,*) 'Error creating Gaussian94 Freq input file'
      stop 'proghhk 2'
9993  write (outfile,*) 'Error creating Gaussian03 Freq input file'
      stop 'proghhk 3'
9994  write (outfile,*) 'Error creating Gaussian09 Freq input file'
      stop 'proghhk 4'
      end
c
c
c*****************************************************************************
c  G98OUTH
c*****************************************************************************
c  
      subroutine g98outh (esmeth, hess, natoms)
c
c     Subroutine g98outh
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Get the hessian out of the Gaussian98 formatted
c        checkpoint file.  (Also used for Gaussian94)
c
c     Called by:  proghhk
c     Calls:
c
c     Variables defined here: 
c     
      use files
      use numfmt
      implicit none
      
      character*20  esmeth
      double precision  hess(3*natoms,3*natoms), cfltfmt

      integer nhess
     
      integer ctr, i, k, natoms, j, hstrt, hend
      character*80 string, case
      character*15 htxt(3*natoms*(3*natoms+1)/2)

      nhess = 3*natoms*(3*natoms+1)/2
c     
c  Open the formatted checkpoint file.
c
      open( unit=fchk, status='unknown', file=testfchk, err=9900)

      read( fchk, '(a80)', end=9910 ) string
      string = case(string)
 
      do while( string(:25).ne.'cartesian force constants' )
         read( fchk, '(a80)', end=9910 ) string
         string = case(string)
      enddo

      ctr = 1
      do while( ctr .le. nhess )
         read( fchk, '(a80)', end=9910 ) string
         string = case(string)
         i = 0
         do while( ctr.le.nhess .and. i.lt.5 )
            hstrt = i*(nlen(hfmt)+1)+2
            hend  = (i+1)*(nlen(hfmt)+2)
            htxt(ctr) = string(hstrt:hend)
            ctr = ctr+1
            i = i+1
         end do
      end do

      j=1
      k=1
c
c  Convert the array of numbers into a full hessian matrix, taking into
c    account that the Gaussian checkpoint file contains only the lower
c    triangular portion of the matrix 
c
      do 20 i=1, nhess
         hess(j,k) = cfltfmt(htxt(i),hfmt)
         if ( j .eq. k) then
            j = j+1
            k = 1
         else
            hess(k,j) = hess(j,k)
            k = k+1
         endif
  20  continue

      close( unit=fchk )

      return

9900  write( outfile,*) 'Error opening Gaussian98 checkpoint file'
      stop 'g98outh 1'
9910  write( outfile,*) 'Error reading Gaussian98 checkpoint file'
      stop 'g98outh 2'

      end
c
c
c******************************************************************************
c  HFMOHHK
c******************************************************************************
c
      subroutine hfmohhk(hfprognme, moprognme, geom, hfmoinp, ierr)
c
c     Subroutine hfmohhk
c  
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To determine the HF||MO energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calhfmo, hfmodisp
c
c     Variables defined here:  none.
c
      use caltyp, only : thess
      use input, only : cartgeom, hfmoinf
      use param, only : esmlist, fesmlist, phf
      use files, only : outfile
      use energy, only : hfmoener
      use gradient, only : hfmograd
      use hessian, only : hfmohess
      implicit none
c
      character*10 hfprognme, moprognme
      type (cartgeom) :: geom
      type (hfmoinf)  :: hfmoinp
      integer ierr, i, j
      integer  n3tm  

      n3tm = 3*geom%natoms

      call proghhk(hfprognme, esmlist(phf), hfmoinp%hfkbas, geom,
     *       hfmoinp%hfkoptl,hfmoener(1),hfmograd(1,:n3tm),
     *       hfmohess(1,:n3tm,:n3tm), ierr, 'null')
      call proghhk(moprognme, hfmoinp%mokmeth, '   ', geom,
     *       hfmoinp%mokoptl,hfmoener(2),hfmograd(2,:n3tm), 
     *       hfmohess(2,:n3tm,:n3tm), ierr, 'null')
 
      call calhfmo(hfmoener(3),hfmoinp%frachf,hfmoener(1),hfmoener(2))
      do 20 i=1, n3tm
         call calhfmo(hfmograd(3,i), hfmoinp%frachf, hfmograd(1,i),
     *                   hfmograd(2,i))
  20  continue
      do 40 i=1, n3tm
         do 60 j=1, i
            call calhfmo(hfmohess(3,i,j), hfmoinp%frachf, 
     *                    hfmohess(1,i,j), hfmohess(2,i,j))
            if (j.ne.i)  hfmohess(3,j,i) = hfmohess(3,i,j)
  60     continue
  40  continue

      call hfmodisp(geom%natoms, thess)

      return
      end
c
c******************************************************************************
c  G2HHK
c******************************************************************************
c
      subroutine g2hhk(prognme, geom, lmg2, g2inp, ierr)
c
c     Created:  July 15, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To get G2 energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calg, g2disp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, ginf
      use gparam
      use files, only : outfile
      use energy, only : g2es, g2ener
      use gradient, only : g2esgr, g2grad
      use hessian, only : g2eshs, g2hess

      implicit none

      character*10     :: prognme
      type (cartgeom)  :: geom
      type (ginf)      :: g2inp
      integer          :: ierr, lmg2, i, j, n3tm

      double precision, parameter :: a = 0.00500d0
      double precision, parameter :: b = 0.00019d0

      double precision :: gethlc

      n3tm = 3*geom%natoms
c     
c  If an MCG2 calculation has already been done then a lot of the 
c    energies and gradients have already been collected in g2es.
c
      if (lmg2 .eq. 1) then
         call proghhk(prognme, g2esml(4), g2basl(4), geom,
     *                  g2inp%optl, g2es(4), g2esgr(4,:n3tm), 
     *                  g2eshs(4,:n3tm,:n3tm), ierr,'null')
         call proghhk(prognme, g2esml(5), g2basl(5), geom,
     *                  g2inp%optl, g2es(5), g2esgr(5,:n3tm),
     *                  g2eshs(5,:n3tm,:n3tm), ierr,'null')
      else
         do 20 i=1, numg2es
            call proghhk(prognme, g2esml(i), g2basl(i), geom,
     *                     g2inp%optl,g2es(i),g2esgr(i,:n3tm),
     *                     g2eshs(i,:n3tm,:n3tm),ierr,'null')
  20     continue
      endif
c
c  Add HLC correction - 0 for the gradient
c
      g2es(phlc) = gethlc(g2inp%alpha, g2inp%beta, a, b)
      do 40 i=1, n3tm
         g2esgr(phlc,i) = 0.0000d0
  40  continue
c
c  No SO correction for g2
c
      g2es(pso)  = 0.0000d0
      do 60 i=1, n3tm
         g2esgr(pso,i)  = 0.0000d0
         do 70 j=1, n3tm
            g2eshs(pso,i,j) = 0.0000d0
  70     continue
  60  continue
      
      call calg(g2ener, g2es)
      do 80 i=1, n3tm
         call calg(g2grad(i), g2esgr(:,i))
         do 90 j=1, i
            call calg(g2hess(i,j), g2eshs(:,i,j))
            if (i.ne.j)  g2hess(j,i) = g2hess(i,j)
  90     continue
  80  continue

      call g2disp(geom%natoms,thess)

      return
      end
c
c******************************************************************************
c  MG2HHK
c******************************************************************************
c     
      subroutine mg2hhk(prognme, geom, mg2inp, ierr)
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To get MCG2 energies, gradients, and hessians
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calmg2, mg2disp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mginf
      use gparam
      use energy, only : mg2ener,mg2es,eso,ecc,erel,g2es
      use gradient, only : mg2grad, mg2esgr, g2esgr
      use hessian, only : mg2hess, mg2eshs, g2eshs
      use files, only : outfile

      implicit none
         
      character*10     :: prognme
      type (cartgeom)  :: geom
      type (mginf)     :: mg2inp
      integer          :: ierr, i, j, k

c
c  Gather all the energies necessary to calculate MCG2 energies.
c  Definitions of each calculation called can be found in the module
c    gparam.
c
      do 20 i=1, nummg2es
         call proghhk(prognme, mg2esml(i), mg2basl(i), geom,
     *          mg2inp%optl, mg2es(i), mg2esgr(i,:3*geom%natoms), 
     *      mg2eshs(i,:3*geom%natoms,:3*geom%natoms),ierr,'null')
  20  continue
c
c  Pass on duplicate info to g2es, so won't have to be reproduced if a g2
c    calculation has been specifed.
c
      g2es(1) = mg2es(2)
      g2es(2) = mg2es(4)
      g2es(3) = mg2es(5)
      g2es(6) = mg2es(6)
      g2es(7) = mg2es(8)
      g2es(8) = mg2es(10)

      g2esgr(1,:) = mg2esgr(2,:)
      g2esgr(2,:) = mg2esgr(4,:)
      g2esgr(3,:) = mg2esgr(5,:)
      g2esgr(6,:) = mg2esgr(6,:)
      g2esgr(7,:) = mg2esgr(8,:)
      g2esgr(8,:) = mg2esgr(10,:)

      g2eshs(1,:,:) = mg2eshs(2,:,:) 
      g2eshs(2,:,:) = mg2eshs(4,:,:) 
      g2eshs(3,:,:) = mg2eshs(5,:,:) 
      g2eshs(6,:,:) = mg2eshs(6,:,:) 
      g2eshs(7,:,:) = mg2eshs(8,:,:) 
      g2eshs(8,:,:) = mg2eshs(10,:,:) 
c
c  Calculate the MCG2 energy and gradient
c
      call calmg2(mg2ener, mg2inp%mcoef, mg2es)
      mg2ener = mg2ener + eso + ecc + erel
      do 40 j=1, 3*geom%natoms
         call calmg2(mg2grad(j), mg2inp%mcoef, mg2esgr(:,j))
         do 50 k=1, j
            call calmg2( mg2hess(j,k), mg2inp%mcoef,
     *               mg2eshs(:,j,k) )
            if (j.ne.k)  mg2hess(k,j) = mg2hess(j,k)
  50     continue
  40  continue
c     
      call mg2disp(geom%natoms,thess)         
      
      return
      end
c
c******************************************************************************
c  G3HHK
c******************************************************************************
c
      subroutine g3hhk(prognme, geom, lmg3, g3inp, ierr)
c
c     Created:  July 15, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To get G3 energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calg, g3disp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, ginf
      use gparam
      use files, only : outfile
      use energy, only : g3es, g3ener
      use gradient, only : g3esgr, g3grad
      use hessian, only : g3eshs, g3hess

      implicit none

      character*10     :: prognme
      type (cartgeom)  :: geom
      type (ginf)      :: g3inp
      integer          :: ierr, i, j, lmg3, n3tm

      double precision, parameter :: a = 0.006386d0
      double precision, parameter :: b = 0.002977d0
      double precision, parameter :: c = 0.006219d0
      double precision, parameter :: d = 0.001185d0

      double precision :: gethlc, getso

      n3tm = 3*geom%natoms
c
c  If an MCG3 calculation has already been done then a lot of the
c    energies and gradients have already been collected in g3es.
c
      if (lmg3 .eq. 1) then
         call proghhk(prognme, g3esml(4), g3basl(4), geom,
     *                  g3inp%optl, g3es(4), g3esgr(4,:n3tm), 
     *                  g3eshs(4,:n3tm,:n3tm), ierr,'null')
         call proghhk(prognme, g3esml(5), g3basl(5), geom,
     *                  g3inp%optl, g3es(5), g3esgr(5,:n3tm), 
     *                  g3eshs(5,:n3tm,:n3tm), ierr,'null')
         call proghhk(prognme, g3esml(7), g3basl(7), geom,
     *                  g3inp%optl, g3es(7), g3esgr(7,:n3tm),
     *                  g3eshs(7,:n3tm,:n3tm), ierr,'null')
         call proghhk(prognme, g3esml(8), g3basl(8), geom,
     *                  g3inp%optl, g3es(8), g3esgr(8,:n3tm), 
     *                  g3eshs(8,:n3tm,:n3tm), ierr,'null')
      else
         do 20 i=1, numg3es
            call proghhk(prognme, g3esml(i), g3basl(i), geom,
     *                     g3inp%optl, g3es(i), g3esgr(i,:n3tm),
     *                     g3eshs(i,:n3tm,:n3tm), ierr,'null')
  20     continue
      endif
c
c  Get the HLC and SO - 0 for gradients
c
      if (geom%natoms.eq.1) then
         g3es(phlc) = gethlc(g3inp%alpha, g3inp%beta, c, d)
         g3es(pso)  = getso(geom%atm(1), geom%charge)
      else
         g3es(phlc) = gethlc(g3inp%alpha, g3inp%beta, a, b)
         g3es(pso)  = 0.0000d0
      endif

      do 40 i=1, n3tm
         g3esgr(phlc,i) = 0.0000d0
         g3esgr(pso,i)  = 0.0000d0
         do 50 j=1, n3tm
            g3eshs(phlc,i,j) = 0.0000d0
            g3eshs(pso,i,j)  = 0.0000d0
  50     continue
  40  continue

      call calg(g3ener, g3es)
      do 60 i=1, n3tm
         call calg(g3grad(i), g3esgr(:,i))
         do 70 j=1, i
            call calg(g3hess(i,j), g3eshs(:,i,j))
            if (i.ne.j)   g3hess(j,i) = g3hess(i,j)
  70     continue
  60  continue

      call g3disp(geom%natoms,thess)

      return
      end
c    
c******************************************************************************
c  MG3HHK
c******************************************************************************
c
      subroutine mg3hhk(prognme, geom, mg3inp, ierr)
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:  January 11, 2000 by P. L. Fast
c     Purpose:  To get MCG3 energies, gradients, and hessians
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calmg3, mg3disp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mginf
      use gparam
      use energy, only : mg3ener,mg3es,eso,ecc,erel,g3es, mqces 
      use gradient, only : mg3grad, mg3esgr, g3esgr, mqcesgr 
      use hessian, only : mg3hess,  mg3eshs, g3eshs, mqceshs 
      use files, only : outfile
     
      implicit none
     
      character*20      ver_lab      
      character*10     :: prognme
      type (cartgeom)  :: geom
      type (mginf)     :: mg3inp
      integer          :: ierr, i, j, k
      
      ver_lab = mg3inp%version

c
c  Gather all the energies necessary to calculate MCG3 energies.
c  Definitions of each calculation called can be found in the module
c    gparam.
c
      if((ver_lab(:3).eq.'v3s').or.(ver_lab(:3).eq.'v3m'))then
      do 10 i=1, 8
         call proghhk(prognme, mg3esml_3(i), mg3basl_3(i), geom,
     *          mg3inp%optl, mg3es(i), mg3esgr(i,:3*geom%natoms),
     *          mg3eshs(i,:3*geom%natoms,:3*geom%natoms), ierr
     *          ,ver_lab)
  10  continue

      else
      do 20 i=1, nummg3es
         call proghhk(prognme, mg3esml(i), mg3basl(i), geom,
     *          mg3inp%optl, mg3es(i), mg3esgr(i,:3*geom%natoms),
     *          mg3eshs(i,:3*geom%natoms,:3*geom%natoms), ierr
     *          ,ver_lab)
  20  continue
      endif

c  Pass on some energies to g3es so won't have to be recalculated in g3
c    is also selected.
c
c this needs to be fixed to work with version 3 coefficients
c
C      g3es(1) = mg3es(2)
C      g3es(2) = mg3es(4)
C      g3es(3) = mg3es(5)
C      g3es(6) = mg3es(6)

C      g3esgr(1,:) = mg3esgr(2,:)
C      g3esgr(2,:) = mg3esgr(4,:)
C      g3esgr(3,:) = mg3esgr(5,:)
C      g3esgr(6,:) = mg3esgr(6,:)

C      g3eshs(1,:,:) = mg3eshs(2,:,:) 
C      g3eshs(2,:,:) = mg3eshs(4,:,:) 
C      g3eshs(3,:,:) = mg3eshs(5,:,:) 
C      g3eshs(6,:,:) = mg3eshs(6,:,:) 
c
c  Pass energies, gradients, and hessians components that can be reused if
c    mqcisd has also been selected
c
C      mqces(1) = mg3es(1)                                               0111PF00
C      mqces(2) = mg3es(2)                                               0111PF00
C      mqces(4) = mg3es(9)                                               0111PF00

C      mqcesgr(1,:) = mg3esgr(1,:)                                       0111PF00
C      mqcesgr(2,:) = mg3esgr(2,:)                                       0111PF00
C      mqcesgr(4,:) = mg3esgr(9,:)                                       0111PF00

C      mqceshs(1,:,:) = mg3eshs(1,:,:)                                   0111PF00
C      mqceshs(2,:,:) = mg3eshs(2,:,:)                                   0111PF00
C      mqceshs(4,:,:) = mg3eshs(9,:,:)                                   0111PF00
c
c  Calculate the MCG3 energy and gradient and hessian
c
      call calmg3(mg3ener, mg3inp%mcoef, mg3es,ver_lab)                 0224BL02
      mg3ener = mg3ener + eso + ecc + erel
      do 40 j=1, 3*geom%natoms                                          0809BL00
         call calmg3(mg3grad(j), mg3inp%mcoef, mg3esgr(:,j),ver_lab)    0224BL02
         do 50 k=1, j
            call calmg3( mg3hess(j,k), mg3inp%mcoef,
     *               mg3eshs(:,j,k),ver_lab )                           0224BL02
            if (j.ne.k)  mg3hess(k,j) = mg3hess(j,k)
  50     continue
  40  continue
c     
      call mg3disp(geom%natoms,thess,ver_lab)
      
      return
      end
c
c******************************************************************************
c  MQCHHK
c******************************************************************************
c
      subroutine mqchhk(prognme, geom, lmg3, mqcinp, ierr)
c
c     Created:  January 11, 2000 by P. L. Fast
c     Revised:
c     Purpose:  To get MC-QCISD energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calmqc, mqcdisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mginf
      use gparam
      use files, only : outfile
      use energy, only : mqces, mqcener
      use gradient, only : mqcesgr, mqcgrad
      use hessian, only : mqceshs, mqchess

      implicit none

      character*20     ver_lab
      character*10     :: prognme
      type (cartgeom)  :: geom
      type (mginf)     :: mqcinp
      integer          :: ierr, i, j, lmg3, n3tm

      ver_lab = mqcinp%version
      n3tm = 3*geom%natoms
c
c  If an MCG3 calculation has already been done then a lot of the
c    energies and gradients have already been collected in mqces.
c
C      if (lmg3 .eq. 1) then
C         call proghhk(prognme, mqcesml(3), mqcbasl(3), geom,
C     *                  mqcinp%optl, mqces(3), mqcesgr(3,:n3tm),
C     *                  mqceshs(3,:n3tm,:n3tm), ierr)
      if((ver_lab(:3).eq.'v3s').or.(ver_lab(:3).eq.'v3m'))then
         do 10 i=1, 5
            call proghhk(prognme, mqcesml_3(i), mqcbasl_3(i), geom,
     *                     mqcinp%optl, mqces(i), mqcesgr(i,:n3tm),
     *                     mqceshs(i,:n3tm,:n3tm), ierr,ver_lab)
  10     continue
      else
         do 20 i=1, nummqces
            call proghhk(prognme, mqcesml(i), mqcbasl(i), geom,
     *                     mqcinp%optl, mqces(i), mqcesgr(i,:n3tm),
     *                     mqceshs(i,:n3tm,:n3tm), ierr,ver_lab)
  20     continue
      endif
c
      call calmqc(mqcener, mqcinp%mqcoef, mqces,ver_lab)
      do 60 i=1, n3tm
         call calmqc(mqcgrad(i),mqcinp%mqcoef,mqcesgr(:,i),ver_lab)
         do 70 j=1, i
            call calmqc(mqchess(i,j), mqcinp%mqcoef, mqceshs(:,i,j)
     *  ,ver_lab)
            if (i.ne.j)   mqchess(j,i) = mqchess(i,j)
  70     continue
  60  continue

      call mqcdisp(geom%natoms,thess,ver_lab)

      return
      end
c
c******************************************************************************
c  MCOMP2HHK
c******************************************************************************
c
      subroutine mcomp2hhk(prognme, geom, lmg3, mcomp2inp, ierr)
c
c     Created:  January 11, 2000 by P. L. Fast
c     Revised:  July 10, 2000 by Jingzhi Pu
c     Purpose:  To get MCOMP2 energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calmqc, mcomp2disp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mginf
      use gparam
      use files, only : outfile
      use energy, only : mcomp2es, mcomp2ener
      use gradient, only : mcomp2esgr, mcomp2grad
      use hessian, only : mcomp2eshs, mcomp2hess

      implicit none

      character*20     ver_lab
      character*10     :: prognme
      type (cartgeom)  :: geom
      type (mginf)     :: mcomp2inp
      integer          :: ierr, i, j, lmg3, n3tm

      ver_lab = mcomp2inp%version
      n3tm = 3*geom%natoms
c
c  If an MCG3 calculation has already been done then a lot of the
c    energies and gradients have already been collected in mcomp2es.
c
C      if (lmg3 .eq. 1) then                                              0224BL02
C         call proghhk(prognme, mcomp2esml(3), mcomp2basl(3),             0224BL02
C     *                geom,mcomp2inp%optl, mcomp2es(3),                  0224BL02
C     *                mcomp2esgr(3,:n3tm),                               0224BL02 
C     *                mcomp2eshs(3,:n3tm,:n3tm),ierr,ver_lab)            0224BL02


      if((ver_lab(:3).eq.'v3s').or.(ver_lab(:3).eq.'v3m'))then
          do 10 i=1, nummcomp2es
          call proghhk(prognme,mcomp2esml_3(i),mcomp2basl_3(i),
     *                 geom, mcomp2inp%optl, mcomp2es(i),
     *                 mcomp2esgr(i,:n3tm),
     *                 mcomp2eshs(i,:n3tm,:n3tm),ierr,ver_lab)
  10     continue
      else                                                               0711PJ00
         do 20 i=1, nummcomp2es
            call proghhk(prognme, mcomp2esml(i), mcomp2basl(i), 
     *                 geom, mcomp2inp%optl, mcomp2es(i),
     *                 mcomp2esgr(i,:n3tm),
     *                 mcomp2eshs(i,:n3tm,:n3tm),ierr,ver_lab)
  20     continue
      endif                                                              0711PJ00 
c
      call calmcomp2(mcomp2ener, mcomp2inp%mcomp2coef, mcomp2es)         
      do 60 i=1, n3tm
         call calmcomp2(mcomp2grad(i), mcomp2inp%mcomp2coef,
     *                  mcomp2esgr(:,i))
         do 70 j=1, i
            call calmcomp2(mcomp2hess(i,j), mcomp2inp%mcomp2coef, 
     *                     mcomp2eshs(:,i,j))
            if (i.ne.j)   mcomp2hess(j,i) = mcomp2hess(i,j)
  70     continue
  60  continue

      call mcomp2disp(geom%natoms,thess,ver_lab)

      return
      end

c
c******************************************************************************
c  MCCOHHK
c******************************************************************************
c
      subroutine mccohhk(prognme, geom, lmg3, mccoinp, ierr)
c
c     Created:  January 12, 2002 by B. J. Lynch
c     Revised:  
c     Purpose:  To get MCCO energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calmqc, mccodisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mginf
      use gparam
      use files, only : outfile
      use energy, only : mccoes, mccoener
      use gradient, only : mccoesgr, mccograd
      use hessian, only : mccoeshs, mccohess

      implicit none

      character*20     ver_lab
      character*10     :: prognme
      type (cartgeom)  :: geom
      type (mginf)     :: mccoinp
      integer          :: ierr, i, j, lmg3, n3tm

      ver_lab = mccoinp%version
      n3tm = 3*geom%natoms

         do 20 i=1, nummccoes
            call proghhk(prognme, mccoesml(i), mccobasl(i), 
     *                 geom, mccoinp%optl, mccoes(i),
     *                 mccoesgr(i,:n3tm),
     *                 mccoeshs(i,:n3tm,:n3tm),ierr,ver_lab)
  20     continue


c
      call calmcco(mccoener, mccoinp%mccocoef, mccoes)         
      do 60 i=1, n3tm
         call calmcco(mccograd(i), mccoinp%mccocoef,
     *                  mccoesgr(:,i))
         do 70 j=1, i
            call calmcco(mccohess(i,j), mccoinp%mccocoef, 
     *                     mccoeshs(:,i,j))
            if (i.ne.j)   mccohess(j,i) = mccohess(i,j)
  70     continue
  60  continue

      call mccodisp(geom%natoms,thess,ver_lab)

      return
      end


c
c******************************************************************************
c  MC3BBHHK
c******************************************************************************
c
      subroutine mc3bbhhk(prognme, geom, lmg3, mc3bbinp, ierr)
c
c     Created:  Dec. 12, 2003 by Yan Zhao
c     Revised:
c     Purpose:  To get MC3BB energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calmqc, mc3bbdisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mginf
      use gparam
      use files, only : outfile
      use energy, only : mc3bbes, mc3bbener
      use gradient, only : mc3bbesgr, mc3bbgrad
      use hessian, only : mc3bbeshs, mc3bbhess

      implicit none

      character*20     ver_lab
      character*10     :: prognme
      type (cartgeom)  :: geom
      type (mginf)     :: mc3bbinp
      integer          :: ierr, i, j, lmg3, n3tm

      ver_lab = mc3bbinp%version
      n3tm = 3*geom%natoms

         do 20 i=1, nummc3bbes
            call proghhk(prognme, mc3bbesml(i), mc3bbbasl(i),
     *                 geom, mc3bbinp%optl, mc3bbes(i),
     *                 mc3bbesgr(i,:n3tm),
     *                 mc3bbeshs(i,:n3tm,:n3tm),ierr,ver_lab)
  20     continue


c
      call calmc3bb(mc3bbener, mc3bbinp%mc3bbcoef, mc3bbes)
      do 60 i=1, n3tm
         call calmc3bb(mc3bbgrad(i), mc3bbinp%mc3bbcoef,
     *                  mc3bbesgr(:,i))
         do 70 j=1, i
            call calmc3bb(mc3bbhess(i,j), mc3bbinp%mc3bbcoef,
     *                     mc3bbeshs(:,i,j))
            if (i.ne.j)   mc3bbhess(j,i) = mc3bbhess(i,j)
  70     continue
  60  continue

      call mc3bbdisp(geom%natoms,thess,ver_lab)

      return
      end


c
c******************************************************************************
c  MC3MPWHHK
c******************************************************************************
c
      subroutine mc3mpwhhk(prognme, geom, lmg3, mc3mpwinp, ierr)
c
c     Created:  Dec. 12, 2003 by Yan Zhao
c     Revised:
c     Purpose:  To get MC3MPW energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calmqc, mc3mpwdisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mginf
      use gparam
      use files, only : outfile
      use energy, only : mc3mpwes, mc3mpwener
      use gradient, only : mc3mpwesgr, mc3mpwgrad
      use hessian, only : mc3mpweshs, mc3mpwhess

      implicit none

      character*20     ver_lab
      character*10     :: prognme
      type (cartgeom)  :: geom
      type (mginf)     :: mc3mpwinp
      integer          :: ierr, i, j, lmg3, n3tm

      ver_lab = mc3mpwinp%version
      n3tm = 3*geom%natoms

         do 20 i=1, nummc3mpwes
            call proghhk(prognme, mc3mpwesml(i), mc3mpwbasl(i),
     *                 geom, mc3mpwinp%optl, mc3mpwes(i),
     *                 mc3mpwesgr(i,:n3tm),
     *                 mc3mpweshs(i,:n3tm,:n3tm),ierr,ver_lab)
  20     continue


c
      call calmc3mpw(mc3mpwener, mc3mpwinp%mc3mpwcoef, mc3mpwes)
      do 60 i=1, n3tm
         call calmc3mpw(mc3mpwgrad(i), mc3mpwinp%mc3mpwcoef,
     *                  mc3mpwesgr(:,i))
         do 70 j=1, i
            call calmc3mpw(mc3mpwhess(i,j), mc3mpwinp%mc3mpwcoef,
     *                     mc3mpweshs(:,i,j))
            if (i.ne.j)   mc3mpwhess(j,i) = mc3mpwhess(i,j)
  70     continue
  60  continue

      call mc3mpwdisp(geom%natoms,thess,ver_lab)

      return
      end



c
c******************************************************************************
c  G3SX(MP3)HHK
c******************************************************************************
c
      subroutine g3sxmp3hhk(prognme, geom, lmg3, g3sxmp3inp, ierr)
c
c     Created:  Dec. 12, 2003 by Yan Zhao
c     Revised:
c     Purpose:  To get MC3BB energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, calmqc, mc3bbdisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mginf
      use gparam
      use files, only : outfile
      use energy, only : g3sxmp3es, g3sxmp3ener
      use gradient, only : g3sxmp3esgr, g3sxmp3grad
      use hessian, only : g3sxmp3eshs, g3sxmp3hess

      implicit none

      character*20     ver_lab
      character*10     :: prognme
      type (cartgeom)  :: geom
      type (mginf)     :: g3sxmp3inp
      integer          :: ierr, i, j, lmg3, n3tm

      ver_lab = g3sxmp3inp%version
      n3tm = 3*geom%natoms

         do 20 i=1, numg3sxmp3es
            call proghhk(prognme, g3sxmp3esml(i), g3sxmp3basl(i),
     *                 geom, g3sxmp3inp%optl, g3sxmp3es(i),
     *                 g3sxmp3esgr(i,:n3tm),
     *                 g3sxmp3eshs(i,:n3tm,:n3tm),ierr,ver_lab)
  20     continue


c
      call calg3sxmp3(g3sxmp3ener, g3sxmp3inp%g3sxmp3coef, g3sxmp3es)
      do 60 i=1, n3tm
         call calg3sxmp3(g3sxmp3grad(i), g3sxmp3inp%g3sxmp3coef,
     *                  g3sxmp3esgr(:,i))
         do 70 j=1, i
            call calg3sxmp3(g3sxmp3hess(i,j), g3sxmp3inp%g3sxmp3coef,
     *                     g3sxmp3eshs(:,i,j))
            if (i.ne.j)   g3sxmp3hess(j,i) = g3sxmp3hess(i,j)
  70     continue
  60  continue

      call g3sxmp3disp(geom%natoms,thess,ver_lab)

      return
      end




c
c******************************************************************************
c  MCOHHK
c******************************************************************************
c
      subroutine mcohhk(prognme,geom,mcoinp,optl)
c
c     Subroutine mcohhk
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To carry out an MCCM-CO calculation with non-standard
c        bases (non-standard methods currently not supported).  Makes all
c        electronic structure program calls and parses electronic
c        information to pass on to calmco.  Energy; Gradient; Hessian
c
c     Called by:  mchhk, opthhk
c     Calls:  proghhk, calmco, mcodisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mcinf
      use param
      use files, only : outfile
      use energy, only : mcener, eso, ecc, erel
      use gradient, only : mcgrad
      use hessian, only : mchess
      implicit none

      character*10  prognme
      type (cartgeom) ::  geom
      type (mcinf)    ::  mcoinp
      integer  ierr, max, i, j, k, l, mcoessw(5)
      double precision  mcoes(5,2)
      double precision  mcoesgr(5,2,3*geom%natoms)
      double precision  mcoeshs(5,2,3*geom%natoms, 3*geom%natoms)
      character*20  meth, bas1, bas2
      character*80  optl(5)
      integer n3tm

      n3tm = 3*geom%natoms

      meth = mcoinp%meth
      bas1 = mcoinp%bas1
      bas2 = mcoinp%bas2
c
c  Initialize mcoes(5,2) to 0.0000d0
c
      do 20 i=1, 5
         do 40 j=1, 2
            mcoes(i,j) = 0.0000d0
            do 50 k=1, n3tm
               mcoesgr(i,j,k) = 0.0000d0
               do 55 l=1, n3tm
                  mcoeshs(i,j,k,l) = 0.0000d0
  55           continue
  50        continue
  40     continue
  20  continue
c
c  Set max equal to the number of e.s. levels in the series.
c  Set mcoessw to the appropriate order of theory calls.
c
      if (meth(:7).eq.'ccsd(t)') then
         max = 4
         mcoessw(4) = pccsdt
         mcoessw(3) = pccsd
      elseif (meth(:4).eq.'ccsd') then
         max = 3
         mcoessw(3) = pccsd
      elseif (meth(:6).eq.'mp4sdq') then
         max = 3
         mcoessw(3) = pmp4sdq
      elseif (meth(:3).eq.'mp4') then
         max = 4
         mcoessw(4) = pmp4
         mcoessw(3) = pmp4sdq
      elseif (meth(:3).eq.'mp2') then
         max = 2
      endif

      mcoessw(2) = pmp2
      mcoessw(1) = phf

c
c  Make all calls to electronic structure program
c
      do 58 i=max, 1, -1
         call proghhk(prognme,esmlist(mcoessw(i)), bas2, geom, optl,
     *      mcoes(i,2), mcoesgr(i,2,:),mcoeshs(i,2,:,:),ierr,'null')
         call proghhk(prognme,esmlist(mcoessw(i)), bas1, geom, optl,
     *      mcoes(i,1),mcoesgr(i,1,:),mcoeshs(i,1,:,:),ierr,'null')
  58  continue
c
c  Calculate the MCCM-CO values with calmco using the info 
c    gathered in mcoes/gr/hs and the input coefficients.
c
      call calmco( mcener(pmco), mcoinp%coef(1:10), mcoes, max )
      mcener(pmco) = mcener(pmco) + eso + ecc + erel
      do 60 j=1, n3tm
         call calmco(mcgrad(pmco,j), mcoinp%coef(1:10),
     *            mcoesgr(:,:,j), max)
         do 80 k=1, j
            call calmco(mchess(pmco,j,k), mcoinp%coef(1:10),
     *               mcoeshs(:,:,j,k), max)
            if (j.ne.k)  mchess(pmco,k,j) = mchess(pmco,j,k)
  80     continue
  60  continue

      call mcodisp(mcoessw,max,mcoinp%bas1,mcoinp%bas2,mcoes,
     *               mcoesgr, mcoeshs, geom%natoms, thess)

      return
      end
c
c******************************************************************************
c MUTHHK
c******************************************************************************
c
      subroutine muthhk(prognme,geom,mutinp,optl)
c
c     Subroutine muthhk
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To carry out an MCCM-UT calculation with non-standard
c        bases (non-standard methods currently not supported).  Makes all
c        electronic structure program calls and parses electronic
c        information to pass on to calmut.  Energy; Gradient; Hessian
c
c     Called by:  mchhk, opthhk
c     Calls:  proghhk, calmut, mutdisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mcinf
      use param
      use files, only : outfile
      use energy, only : mcener, eso, ecc, erel
      use gradient, only : mcgrad
      use hessian, only : mchess
      implicit none

      character*10  prognme
      type (cartgeom) ::  geom
      type (mcinf)    ::  mutinp
      integer  ierr, max, i, j, k, l, mutessw(5)
      double precision  mutes(5,2)
      double precision  mutesgr(5,2,3*geom%natoms)
      double precision  muteshs(5,2,3*geom%natoms,3*geom%natoms)
      character*20  meth, bas1, bas2
      character*80  optl(5)
      integer n3tm

      n3tm = 3*geom%natoms

      meth = mutinp%meth
      bas1 = mutinp%bas1
      bas2 = mutinp%bas2
c
c  Initialize mutes(5,2) to 0.0000d0
c
      do 20 i=1, 5
         do 40 j=1, 2
            mutes(i,j) = 0.0000d0
            do 50 k=1, n3tm
               mutesgr(i,j,k) = 0.0000d0
               do 55 l=1, n3tm
                  muteshs(i,j,k,l) = 0.0000d0
  55           continue
  50        continue
  40     continue
  20  continue
c
c  Set max equal to the number of e.s. levels in the series.
c  Goto appropriate place in lines below to gather the necessary energies
c    from the electronic structure program.
c
      if (meth(:7).eq.'ccsd(t)') then
         max = 4
         mutessw(4) = pccsdt
         mutessw(3) = pccsd
      elseif (meth(:4).eq.'ccsd') then
         max = 3
         mutessw(3) = pccsd
      elseif (meth(:6).eq.'mp4sdq') then
         max = 3
         mutessw(3) = pmp4sdq
      elseif (meth(:3).eq.'mp4') then
         max = 4
         mutessw(4) = pmp4
         mutessw(3) = pmp4sdq
      endif

      mutessw(2) = pmp2
      mutessw(1) = phf
c
c  Make all calls to electronic structure program
c
      do 65 i=2, 1, -1
         call proghhk(prognme,esmlist(mutessw(i)), bas2, geom, optl,
     *    mutes(i,2), mutesgr(i,2,:), muteshs(i,2,:,:), ierr,'null')
  65  continue
      do 60 i=max, 1, -1
         call proghhk(prognme,esmlist(mutessw(i)), bas1, geom, optl,
     *    mutes(i,1), mutesgr(i,1,:), muteshs(i,1,:,:), ierr,'null')
  60  continue
c
c  Calculate the MCCM-UT energy with calmut using the energies gathered
c    in mutes and the input coefficients.  Then set the position in the
c    mcener for the non-default MCCM-UT calculation equal to that energy.
c
      call calmut( mcener(pmut), mutinp%coef(1:7), mutes, max )
      mcener(pmut) = mcener(pmut) + eso + ecc + erel
      do 70 j=1, 3*geom%natoms   
         call calmut(mcgrad(pmut,j), mutinp%coef(1:7),
     *            mutesgr(:,:,j), max)
         do 80 k=1, j
            call calmut(mchess(pmut,j,k), mutinp%coef(1:10),
     *               muteshs(:,:,j,k), max)
            if (j.ne.k)  mchess(pmut,k,j) = mchess(pmut,j,k)
  80     continue
  70  continue

      call mutdisp(mutessw,max,mutinp%bas1,mutinp%bas2,mutes,
     *               mutesgr, muteshs, geom%natoms, thess)

      return
      end
c
c******************************************************************************
c MNMHHK
c******************************************************************************
c
      subroutine mnmhhk(prognme,geom,mnminp,optl)
c
c     Subroutine mnmhhk
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To carry out an MCCM-NM calculation with non-standard
c        bases (non-standard methods currently not supported).  Makes all
c        electronic structure program calls and parses electronic
c        information to pass on to calmnm.  Energy; Gradient; Hessian
c
c     Called by:  mchhk, opthhk
c     Calls:  proghhk, calmnm, mnmdisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mcinf
      use files, only : outfile
      use param
      use energy, only : mcener, eso, ecc, erel
      use gradient, only : mcgrad
      use hessian, only : mchess
      implicit none

      character*10  prognme
      type (cartgeom) ::  geom
      type (mcinf)    ::  mnminp
      integer  ierr, max, i, j, k, l, mnmessw(5)
      double precision  mnmes(5,3)
      double precision  mnmesgr(5,3,3*geom%natoms)
      double precision  mnmeshs(5,3,3*geom%natoms,3*geom%natoms)
      character*20  meth, bas1, bas2, bas3
      character*80  optl(5)
      integer n3tm

      n3tm = 3*geom%natoms

      meth = mnminp%meth
      bas1 = mnminp%bas1
      bas2 = mnminp%bas2
      bas3 = mnminp%bas3
c
c  Initialize mnmes(5,3) to 0.0000d0
c
      do 20 i=1, 5
         do 40 j=1, 3
            mnmes(i,j) = 0.0000d0
            do 50 k=1, n3tm
               mnmesgr(i,j,k) = 0.0000d0
               do 55 l=1, n3tm
                  mnmeshs(i,j,k,l) = 0.0000d0
  55           continue
  50        continue
  40     continue
  20  continue
c
c  Set max equal to the number of e.s. levels in the series.
c  Set slots in switch for calculations
c
      if (meth(:7).eq.'ccsd(t)') then
         max = 4
         mnmessw(4) = pccsdt
         mnmessw(3) = pccsd
      endif

      mnmessw(2) = pmp2
      mnmessw(1) = phf

      do 65 i=2, 1, -1
         call proghhk(prognme,esmlist(mnmessw(i)), bas3, geom, optl,
     *    mnmes(i,2), mnmesgr(i,2,:), mnmeshs(i,2,:,:), ierr,'null')
  65  continue
      do 60 i=max, 1, -1
         call proghhk(prognme,esmlist(mnmessw(i)), bas1, geom, optl,
     *    mnmes(i,1), mnmesgr(i,1,:), mnmeshs(i,1,:,:), ierr,'null')
  60  continue

      call proghhk(prognme,esmlist(mnmessw(1)), bas2, geom, optl,
     *   mnmes(1,3), mnmesgr(1,3,:), mnmeshs(1,3,:,:), ierr,'null')

c
c  Calculate the MCCM-NM values with calmnm using the info gathered
c    in mnmes and the input coefficients.
c
      call calmnm( mcener(pmnm), mnminp%coef(1:7), mnmes, max )
      mcener(pmnm) = mcener(pmnm) + eso + ecc + erel
      do 70 j=1, n3tm
         call calmnm(mcgrad(pmnm,j), mnminp%coef(1:7),
     *            mnmesgr(:,:,j), max)
         do 80 k=1, j
            call calmnm(mchess(pmnm,j,k), mnminp%coef(1:10),
     *               mnmeshs(:,:,j,k), max)
            if (j.ne.k)  mchess(pmnm,k,j) = mchess(pmnm,j,k)
  80     continue
  70  continue

      call mnmdisp(mnmessw,max,mnminp%bas1,mnminp%bas2,
     *               mnminp%bas3,mnmes,mnmesgr,mnmeshs,
     *               geom%natoms,thess)

      return
      end
c
c******************************************************************************
c MCSHHK
c******************************************************************************
c
      subroutine mcshhk(prognme,geom,mcsinp,optl)
c
c     Subroutine mcshhk
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To carry out an MCSAC calculation with non-standard
c        bases (non-standard methods currently not supported).  Makes all
c        electronic structure program calls and parses electronic
c        information to pass on to calmcs.  Energy; Gradient; Hessian
c
c     Called by:  mchhk, opthhk
c     Calls:  proghhk, calmcs, mcsdisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mcinf
      use param
      use files, only : outfile
      use energy, only : mcener, eso, ecc, erel
      use gradient, only : mcgrad 
      use hessian, only : mchess
      implicit none

      character*10  prognme
      type (cartgeom) ::  geom
      type (mcinf)    ::  mcsinp
      integer  ierr, max, i, j, k, l, mcsessw(5)
      double precision  mcses(5), mcsesgr(5,3*geom%natoms)
      double precision  mcseshs(5,3*geom%natoms,3*geom%natoms)
      character*20  meth, bas1
      character*80  optl(5)
      integer n3tm

      n3tm = 3*geom%natoms

      meth = mcsinp%meth
      bas1 = mcsinp%bas1
c
c  Initialize mcses(5) to 0.0000d0
c
      do 20 i=1, 5
         mcses(i) = 0.0000d0
         do 50 k=1, n3tm
            mcsesgr(i,k) = 0.0000d0
            do 55 l=1, n3tm
               mcseshs(i,k,l) = 0.0000d0
  55        continue
  50     continue
  20  continue
c
c  Set max equal to the number of e.s. levels in the series.
c  Set switch to appropriate calculations.
c
      if (meth(:7).eq.'ccsd(t)') then
         max = 4
         mcsessw(4) = pccsdt
         mcsessw(3) = pccsd
      elseif (meth(:4).eq.'ccsd') then
         max = 3
         mcsessw(3) = pccsd
      elseif (meth(:6).eq.'mp4sdq') then
         max = 3
         mcsessw(3) = pmp4sdq
      elseif (meth(:3).eq.'mp4') then
         max = 4
         mcsessw(4) = pmp4
         mcsessw(3) = pmp4sdq
      endif

      mcsessw(2) = pmp2
      mcsessw(1) = phf
c
c  Make all calls to electronic structure program
c
      do 60 i=max, 1, -1
         call proghhk(prognme,esmlist(mcsessw(i)), bas1, geom, optl,
     *          mcses(i), mcsesgr(i,:), mcseshs(i,:,:), ierr,'null')
  60  continue

c
c  Calculate the MCSAC values with calmcs using the
c    info gathered in mcses and the input coefficients.
c
      call calmcs( mcener(pmcs), mcsinp%coef(1:4), mcses, max )
      mcener(pmcs) = mcener(pmcs) + eso + ecc + erel
      do 70 j=1, n3tm
         call calmcs( mcgrad(pmcs,j), mcsinp%coef(1:4),
     *            mcsesgr(:,j), max)
         do 80 k=1, j
            call calmcs(mchess(pmcs,j,k), mcsinp%coef(1:10),
     *               mcseshs(:,j,k), max)
            if (j.ne.k)  mchess(pmcs,k,j) = mchess(pmcs,j,k)
  80     continue
  70  continue

      call mcsdisp(mcsessw,max,mcsinp%bas1,mcses,mcsesgr,
     *               mcseshs,geom%natoms,thess)

      return
      end
c
c******************************************************************************
c IBHHK
c******************************************************************************
c
      subroutine ibhhk(prognme,geom,ibinp,optl)
c
c     Subroutine ibhhk
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To carry out an IB calculation with non-standard
c        bases or methods.  Makes all
c        electronic structure program calls and parses electronic
c        information to pass on to calib.  Energy; Gradient; Hessian
c
c     Called by:  mchhk, opthhk
c     Calls:  proghhk, calib, ibdisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mcinf
      use files, only : outfile
      use param
      use energy, only : mcener, eso, ecc, erel
      use gradient, only : mcgrad
      use hessian, only : mchess
      implicit none

      character*10  prognme
      type (cartgeom) ::  geom
      type (mcinf)    ::  ibinp
      integer  ierr, max, i, j, k, l
      double precision  ibes(2,2), ibesgr(2,2,3*geom%natoms)
      double precision  ibeshs(2,2,3*geom%natoms,3*geom%natoms)
      character*20  meth, bas1, bas2
      character*80  optl(5)
      integer n3tm

      n3tm = 3*geom%natoms

      meth = ibinp%meth
      bas1 = ibinp%bas1
      bas2 = ibinp%bas2
c
c  Initialize ibes(2,2) to 0.0000d0
c
      do 20 i=1, 2
         do 40 j=1, 2
            ibes(i,j) = 0.0000d0
            do 50 k=1, n3tm
               ibesgr(i,j,k) = 0.0000d0
               do 55 l=1, n3tm
                  ibeshs(i,j,k,l) = 0.0000d0
  55           continue
  50        continue
  40     continue
  20  continue
c
c  Make calls to the electronic structure program
c
      call proghhk(prognme,meth,bas2,geom,optl,ibes(2,2),
     *        ibesgr(2,2,:), ibeshs(2,2,:,:), ierr,'null')
      call proghhk(prognme,esmlist(phf), bas2, geom, optl, 
     * ibes(1,2), ibesgr(1,2,:), ibeshs(1,2,:,:), ierr,'null')
      call proghhk(prognme,meth,bas1,geom,optl,ibes(2,1),
     *        ibesgr(2,1,:), ibeshs(2,1,:,:), ierr,'null')
      call proghhk(prognme,esmlist(phf), bas1, geom, optl,
     * ibes(1,1), ibesgr(1,1,:), ibeshs(1,1,:,:), ierr,'null')
c
c  Calculate the IB values with calib using the info gathered
c    in ibes and the input coefficients. 
c
      call calib( mcener(pib), ibinp%coef(1), ibinp%coef(2), ibes )
      mcener(pib) = mcener(pib) + eso + ecc + erel
      do 60 j=1, 3*geom%natoms
         call calib(mcgrad(pib,j), ibinp%coef(1), ibinp%coef(2),
     *            ibesgr(:,:,j) )
         do 80 k=1, j

c
c  Commented by Jingzhi Pu, incorrect number of parameter in this       0418PJ01
c  call at Multilevel 2.2 and early versions                            0418PJ01
c
c           call calib(mchess(pib,j,k), ibinp%coef(1), ibinp%coef(2),
c    *               ibeshs(:,:,j,k), max)
c

            call calib(mchess(pib,j,k), ibinp%coef(1), ibinp%coef(2),   0418PJ01
     *                 ibeshs(:,:,j,k) )                                0418PJ01

            if (j.ne.k)  mchess(pib,k,j) = mchess(pib,j,k)
  80     continue
  60  continue

      call ibdisp(ibinp%meth,ibinp%bas1,ibinp%bas2,ibes,
     *             ibesgr,ibeshs,geom%natoms,thess)

      return
      end
c
c******************************************************************************
c SACHHK
c******************************************************************************
c
      subroutine sachhk(prognme,geom,sacinp,optl)
c
c     Subroutine sachhk
c
c     Created:  July 10, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To carry out an SAC calculation with non-standard
c        bases or methods.  Makes all
c        electronic structure program calls and parses electronic
c        information to pass on to calsac.  Energy; Gradient; Hessian
c
c     Called by:  mchhk, opthhk
c     Calls:  proghhk, calsac, sacdisp
c
c     Variables defined here:
c
      use caltyp, only : thess
      use input, only : cartgeom, mcinf
      use files, only : outfile
      use param
      use energy, only : mcener, eso, ecc, erel
      use gradient, only : mcgrad
      use hessian, only : mchess
      implicit none

      character*10  prognme
      type (cartgeom) ::  geom
      type (mcinf)    ::  sacinp
      integer  ierr, max, i, j, k, l
      double precision  saces(2), sacesgr(2,3*geom%natoms)
      double precision  saceshs(2,3*geom%natoms,3*geom%natoms)
      character*20  meth, bas1
      character*80  optl(5)
      integer  n3tm

      n3tm = 3*geom%natoms

      meth = sacinp%meth
      bas1 = sacinp%bas1
c
c  Initialize saces(2) to 0.0000d0
c
      do 20 i=1, 2
         saces(i) = 0.0000d0
         do 30 j=1, n3tm
            sacesgr(i,j) = 0.0000d0
            do 55 l=1, n3tm
               saceshs(i,j,l) = 0.0000d0
  55        continue
  30     continue
  20  continue
c
c  Make all calls to the electronic structure program
c
      call proghhk(prognme,meth,bas1,geom,optl,saces(2),
     *        sacesgr(2,:),saceshs(2,:,:),ierr,'null')
      call proghhk(prognme,esmlist(phf), bas1, geom, optl,
     * saces(1), sacesgr(1,:),saceshs(1,:,:), ierr,'null')
c
c  Calculate the SAC value with calsac using the info gathered
c    in saces and the input coefficients.
c
      call calsac( mcener(psac), sacinp%coef(1), saces )
      mcener(psac) = mcener(psac) + eso + ecc + erel
      do 60 j=1, n3tm
         call calsac(mcgrad(psac,j), sacinp%coef(1), sacesgr(:,j) )
         do 80 k=1, j
c
c  Commented by Jingzhi Pu, incorrect number of parameter in this       0418PJ01
c  call at Multilevel 2.2 and early versions                            0418PJ01
c
c           call calsac(mchess(psac,j,k), sacinp%coef(1:1),
c    *               saceshs(:,j,k), max)
c
           call calsac(mchess(psac,j,k), sacinp%coef(1:1),              0418PJ01
     *               saceshs(:,j,k) )                                   0418PJ01


            if (j.ne.k)  mchess(psac,k,j) = mchess(psac,j,k)
  80     continue
  60  continue

      call sacdisp(sacinp%meth,sacinp%bas1,saces,sacesgr,
     *               saceshs,geom%natoms,thess)

      return
      end
c
c******************************************************************************
c  MTOLTM
c******************************************************************************
c
      subroutine mtoltm( matrix, ltmat, dim )
c
c     Subroutine mtoltm
c
c     Created:  July 12, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To convert a 2 dimensional array matrix to a 1 dimensional
c        array ltmat containing only the lower triangular elements of 
c        matrix.
c
c     Called by:  mcdisp, mcodisp, mnmdisp, mutdisp, mcsdisp, ibdisp,
c        sacdisp, hfmodisp, g2disp, g3disp, mg2disp, mg3disp, imohcdisp,
c        mqcdisp, mcomp2disp, mccodisp, g3sxmp3disp, mc3bbdisp,mc3mpwdisp
c     Calls:
c
c     Variables defined here:
c
      use files, only : outfile
      implicit none

      integer  dim, i, j, ctr
      double precision  matrix(dim,dim), ltmat(dim*(dim+1)/2)

      ctr = 0

      do 20 i=1, dim
         do 40 j=1, i
            ctr = ctr + 1
            ltmat(ctr) = matrix(i,j)
  40     continue
  20  continue

      if (ctr .ne. dim*(dim+1)/2) then
         write(outfile,*) 'ERROR: Problem in MTOLTM'
      endif

      return
      end
c
c******************************************************************************
c  IMOHCHHK
c******************************************************************************
c
      subroutine imohchhk(hlprognme, llprognme, geom, inp, ierr)
c
c     Subroutine imohchhk
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c               Used Ben's structure - just converted to standard Multilevel
c                  subroutines and modules.
c     Purpose:  To determine the IMOHC energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk, hnrg, hgrad, hhess, imohcdisp
c  
c     Variables defined here:  none.
c
      use caltyp, only : thess
      use input, only : cartgeom, imoinf
      use files, only : outfile
      use energy, only : imohcener, imohces
      use gradient, only : imohcgrad, imohcesgr
      use hessian, only : imohchess, imohceshs
      implicit none
c
      character*10 hlprognme, llprognme
      type (cartgeom) :: geom, lsgeom, ssgeom
      type (imoinf)  :: inp
      integer ierr, i, j, k, l
      double precision  r, theta, phi
      double precision  rgrad(6), agrad(9), torgrad(12)
      double precision  rhess(6,6), ahess(9,9), torhess(12,12)
c
c  Assign the appropriate geometries to lsgeom and ssgeom
c
      call hcgeom(geom,lsgeom,ssgeom, inp%lsatm, inp%lsnatm,
     *       inp%ssatm, inp%ssnatm)
c
c  High level calculation on the small system
c
      call proghhk(hlprognme, inp%hlmeth, inp%hlbas, ssgeom,
     *        inp%hloptl, imohces(1), imohcesgr(1,:3*inp%ssnatm), 
     *      imohceshs(1,:3*inp%ssnatm,:3*inp%ssnatm),ierr,'null')
c
c  Low level calculation on the large system
c
      call proghhk(llprognme, inp%llmeth, inp%llbas, lsgeom,
     *        inp%lloptl, imohces(2), imohcesgr(2,:3*inp%lsnatm), 
     *     imohceshs(2,:3*inp%lsnatm,:3*inp%lsnatm), ierr,'null')
c
c  Low level calculation on the small system
c
      call proghhk(llprognme, inp%llmeth, inp%llbas, ssgeom,
     *        inp%lloptl, imohces(3), imohcesgr(3,:3*inp%ssnatm), 
     *     imohceshs(3,:3*inp%ssnatm,:3*inp%ssnatm), ierr,'null')
c
c  Calculate the IMOMO energy, gradient, and hessian
c
      imohcener = imohces(1) + imohces(2) - imohces(3)

      do 60 i=1, inp%lsnatm
         do 70 j=1, 3
            imohcgrad((inp%lsatm(i)-1)*3+j) = imohcesgr(2,(i-1)*3+j)
  70     continue
  60  continue
      do 110 i=1, inp%ssnatm
         do 120 j=1, 3
            imohcgrad((inp%ssatm(i)-1)*3+j) =
     *              imohcgrad((inp%ssatm(i)-1)*3+j) +
     *              imohcesgr(1,(i-1)*3+j) - imohcesgr(3,(i-1)*3+j)
 120     continue
 110  continue
      do 151 i=1, (geom%natoms)*3
      do 152 j=1, (geom%natoms)*3
      imohchess(i,j) = 0.0d0
152   continue
151   continue

      do 150 i=1, inp%lsnatm
         do 160 j=1, inp%lsnatm
            do 170 k=0, 2
               do 180 l=0, 2
                  imohchess(inp%lsatm(i)*3-l,inp%lsatm(j)*3-k) = 
     *                   imohceshs(2,i*3-l,j*3-k)
 180           continue
 170        continue
 160     continue
 150  continue
      do 200 i=1, inp%ssnatm
         do 210 j=1, inp%ssnatm
            do 220 k=0, 2
               do 230 l=0, 2
                  imohchess(inp%ssatm(i)*3-l,inp%ssatm(j)*3-k) =
     *                imohchess(inp%ssatm(i)*3-l,inp%ssatm(j)*3-k) +
     *                imohceshs(1,i*3-l,j*3-k) -
     *                imohceshs(3,i*3-l,j*3-k)
 230           continue
 220        continue
 210     continue
 200  continue

c
c  Add harmonic components to imohcener, imohcgrad, imohchess
c    values altered within the subroutines.
c
      call hnrg( geom, inp%bond, inp%angle, inp%tors, 
     *             r, theta, phi)
      call hgrad( geom, inp%bond, inp%angle, inp%tors,
     *             rgrad, agrad, torgrad )
      call hhess( geom, inp%bond, inp%angle, inp%tors,
     *             rhess, ahess, torhess )
c
c  Display results
c     
      call imohcdisp(r,theta,phi,rgrad,agrad,torgrad,rhess,
     *   ahess,torhess,inp%ssnatm,inp%lsnatm,thess)

      return
      end
c
c******************************************************************************
c  HHESS
c******************************************************************************
c
      subroutine hhess( geom, bond, angle, tors, rhess, ahess, thess )
c
c     Subroutine hhess
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c               Used Ben's structure - just converted to standard Multilevel
c                  subroutines and modules.
c     Purpose:  To add on the harmonic correction to imohchess
c
c     Called by:  imohchhk
c     Calls:  d2xx, d2xy, dax1x1, dax1y1, dax1x2, dax1y2, dax1x3, dax1y3,
c        dax2x2, dax1y3, dx1x1, dx1y1, dx1x2, dx1y2, dx1x3, dx1y3, dx1x4,
c        dx1y4, dx2x2, dx2y2, dx2x3, dx2y3
c
c     Variables defined here:  none.
c
      use input, only : cartgeom, hcinf
      use files, only : outfile
      use hessian, only : imohchess
      implicit none

      type (cartgeom)  :: geom
      type (hcinf)     :: bond, angle, tors
      integer          :: i,j,k,l
      double precision :: x1,x2,y1,y2,z1,z2,x3,x4,y3,y4,z3,z4,
     *   rhess(6,6),ahess(9,9),thess(12,12)
c
c  Bond contribution - use symmetry
c 
        x1 = geom%aucoord(bond%atoms(1)*3-2)
        y1 = geom%aucoord(bond%atoms(1)*3-1)
        z1 = geom%aucoord(bond%atoms(1)*3)
        x2 = geom%aucoord(bond%atoms(2)*3-2)
        y2 = geom%aucoord(bond%atoms(2)*3-1)
        z2 = geom%aucoord(bond%atoms(2)*3)

        CALL d2xx(x1,x2,y1,y2,z1,z2,bond%k,bond%eqval,rhess(1,1))
        CALL d2xx(y1,y2,x1,x2,z1,z2,bond%k,bond%eqval,rhess(2,2))
        CALL d2xx(z1,z2,y1,y2,x1,x2,bond%k,bond%eqval,rhess(3,3))
        CALL d2xy(x1,x2,y1,y2,z1,z2,bond%k,bond%eqval,rhess(1,2))
        CALL d2xy(x1,x2,z1,z2,y1,y2,bond%k,bond%eqval,rhess(1,3))
        CALL d2xy(y1,y2,x1,x2,z1,z2,bond%k,bond%eqval,rhess(2,1))
        CALL d2xy(y1,y2,z1,z2,x1,x2,bond%k,bond%eqval,rhess(2,3))
        CALL d2xy(z1,z2,x1,x2,y1,y2,bond%k,bond%eqval,rhess(3,1))
        CALL d2xy(z1,z2,y1,y2,x1,x2,bond%k,bond%eqval,rhess(3,2))

        do 10 i =1,3
           do 20 j=1,3
              rhess(i+3,j) =  -rhess(i,j)
              rhess(i,j+3) =  -rhess(i,j)
              rhess(i+3,j+3)= rhess(i,j)
  20       continue
  10    continue
c
c  Angle contribution
c
        x1 = geom%aucoord(angle%atoms(1)*3-2)
        y1 = geom%aucoord(angle%atoms(1)*3-1)
        z1 = geom%aucoord(angle%atoms(1)*3)
        x2 = geom%aucoord(angle%atoms(2)*3-2)
        y2 = geom%aucoord(angle%atoms(2)*3-1)
        z2 = geom%aucoord(angle%atoms(2)*3)
        x3 = geom%aucoord(angle%atoms(3)*3-2)
        y3 = geom%aucoord(angle%atoms(3)*3-1)
        z3 = geom%aucoord(angle%atoms(3)*3)

        CALL dax1x1(x1,x2,x3,y1,y2,y3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(1,1))
        CALL dax1x1(y1,y2,y3,x1,x2,x3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(2,2))
        CALL dax1x1(z1,z2,z3,x1,x2,x3,y1,y2,y3,angle%k,
     *          angle%eqval,ahess(3,3))
        CALL dax1x1(x3,x2,x1,y3,y2,y1,z3,z2,z1,angle%k,
     *          angle%eqval,ahess(7,7))
        CALL dax1x1(y3,y2,y1,x3,x2,x1,z3,z2,z1,angle%k,
     *          angle%eqval,ahess(8,8))
        CALL dax1x1(z3,z2,z1,x3,x2,x1,y3,y2,y1,angle%k,
     *          angle%eqval,ahess(9,9))

        CALL dax1y1(x1,x2,x3,y1,y2,y3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(1,2))
        CALL dax1y1(x1,x2,x3,z1,z2,z3,y1,y2,y3,angle%k,
     *          angle%eqval,ahess(1,3))
        CALL dax1y1(y1,y2,y3,x1,x2,x3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(2,3))
        CALL dax1y1(x3,x2,x1,y3,y2,y1,z3,z2,z1,angle%k,
     *          angle%eqval,ahess(7,8))
        CALL dax1y1(x3,x2,x1,z3,z2,z1,y3,y2,y1,angle%k,
     *          angle%eqval,ahess(7,9))
        CALL dax1y1(y3,y2,y1,z3,z2,z1,x3,x2,x1,angle%k,
     *          angle%eqval,ahess(8,9))

        CALL dax1x2(x1,x2,x3,y1,y2,y3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(1,4))
        CALL dax1x2(y1,y2,y3,x1,x2,x3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(2,5))
        CALL dax1x2(z1,z2,z3,y1,y2,y3,x1,x2,x3,angle%k,
     *          angle%eqval,ahess(3,6))
        CALL dax1x2(x3,x2,x1,y3,y2,y1,z3,z2,z1,angle%k,
     *          angle%eqval,ahess(4,7))
        CALL dax1x2(y3,y2,y1,x3,x2,x1,z3,z2,z1,angle%k,
     *          angle%eqval,ahess(5,8))
        CALL dax1x2(z3,z2,z1,y3,y2,y1,x3,x2,x1,angle%k,
     *          angle%eqval,ahess(6,9))

        CALL dax1y2(x1,x2,x3,y1,y2,y3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(1,5))
        CALL dax1y2(x1,x2,x3,z1,z2,z3,y1,y2,y3,angle%k,
     *          angle%eqval,ahess(1,6))
        CALL dax1y2(y1,y2,y3,x1,x2,x3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(2,4))
        CALL dax1y2(y1,y2,y3,z1,z2,z3,x1,x2,x3,angle%k,
     *          angle%eqval,ahess(2,6))
        CALL dax1y2(z1,z2,z3,x1,x2,x3,y1,y2,y3,angle%k,
     *          angle%eqval,ahess(3,4))
        CALL dax1y2(z1,z2,z3,y1,y2,y3,x1,x2,x3,angle%k,
     *          angle%eqval,ahess(3,5))

        CALL dax1y2(x3,x2,x1,y3,y2,y1,z3,z2,z1,angle%k,
     *          angle%eqval,ahess(4,8))
        CALL dax1y2(x3,x2,x1,z3,z2,z1,y3,y2,y1,angle%k,
     *          angle%eqval,ahess(4,9))
        CALL dax1y2(y3,y2,y1,x3,x2,x1,z3,z2,z1,angle%k,
     *          angle%eqval,ahess(5,7))
        CALL dax1y2(y3,y2,y1,z3,z2,z1,x3,x2,x1,angle%k,
     *          angle%eqval,ahess(5,9))
        CALL dax1y2(z3,z2,z1,x3,x2,x1,y3,y2,y1,angle%k,
     *          angle%eqval,ahess(6,7))
        CALL dax1y2(z3,z2,z1,y3,y2,y1,x3,x2,x1,angle%k,
     *          angle%eqval,ahess(6,8))

        CALL dax1x3(x1,x2,x3,y1,y2,y3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(1,7))
        CALL dax1x3(y1,y2,y3,x1,x2,x3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(2,8))
        CALL dax1x3(z1,z2,z3,y1,y2,y3,x1,x2,x3,angle%k,
     *          angle%eqval,ahess(3,9))

        CALL dax1y3(x1,x2,x3,y1,y2,y3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(1,8))
        CALL dax1y3(x1,x2,x3,z1,z2,z3,y1,y2,y3,angle%k,
     *          angle%eqval,ahess(1,9))
        CALL dax1y3(y1,y2,y3,x1,x2,x3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(2,7))
        CALL dax1y3(y1,y2,y3,z1,z2,z3,x1,x2,x3,angle%k,
     *          angle%eqval,ahess(2,9))
        CALL dax1y3(z1,z2,z3,x1,x2,x3,y1,y2,y3,angle%k,
     *          angle%eqval,ahess(3,7))
        CALL dax1y3(z1,z2,z3,y1,y2,y3,x1,x2,x3,angle%k,
     *          angle%eqval,ahess(3,8))

        CALL dax2x2(x1,x2,x3,y1,y2,y3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(4,4))
        CALL dax2x2(y1,y2,y3,x1,x2,x3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(5,5))
        CALL dax2x2(z1,z2,z3,y1,y2,y3,x1,x2,x3,angle%k,
     *          angle%eqval,ahess(6,6))

        CALL dax1y3(x1,x2,x3,y1,y2,y3,z1,z2,z3,angle%k,
     *          angle%eqval,ahess(4,5))
        CALL dax1y3(x1,x2,x3,z1,z2,z3,y1,y2,y3,angle%k,
     *          angle%eqval,ahess(4,6))
        CALL dax1y3(y1,y2,y3,z1,z2,z3,x1,x2,x3,angle%k,
     *          angle%eqval,ahess(5,6))
c
c  Apply symmetry to ahess
c
      do 23 i=1, 9
         do 24 j=1, i
            ahess(i,j) = ahess(j,i)
  24     continue
  23  continue
c
c  Torsion contribution
c
        x1 = geom%aucoord(tors%atoms(1)*3-2)
        y1 = geom%aucoord(tors%atoms(1)*3-1)
        z1 = geom%aucoord(tors%atoms(1)*3)
        x2 = geom%aucoord(tors%atoms(2)*3-2)
        y2 = geom%aucoord(tors%atoms(2)*3-1)
        z2 = geom%aucoord(tors%atoms(2)*3)
        x3 = geom%aucoord(tors%atoms(3)*3-2)
        y3 = geom%aucoord(tors%atoms(3)*3-1)
        z3 = geom%aucoord(tors%atoms(3)*3)
        x4 = geom%aucoord(tors%atoms(4)*3-2)
        y4 = geom%aucoord(tors%atoms(4)*3-1)
        z4 = geom%aucoord(tors%atoms(4)*3)

        CALL dx1x1(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(1,1))
        CALL dx1x1(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(2,2))
        CALL dx1x1(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(3,3))
        CALL dx1x1(x4,x3,x2,x1,y4,y3,y2,y1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(10,10))
        CALL dx1x1(y4,y3,y2,y1,x4,x3,x2,x1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(11,11))
        CALL dx1x1(z4,z3,z2,z1,y4,y3,y2,y1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(12,12))

        CALL dx1y1(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(1,2))
        CALL dx1y1(x1,x2,x3,x4,z1,z2,z3,z4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(1,3))
        CALL dx1y1(y1,y2,y3,y4,z1,z2,z3,z4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(2,3))
        CALL dx1y1(x4,x3,x2,x1,y4,y3,y2,y1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(10,11))
        CALL dx1y1(x4,x3,x2,x1,z4,z3,z2,z1,y4,y3,y2,y1,
     *          tors%k,tors%eqval,thess(10,12))
        CALL dx1y1(y4,y3,y2,y1,z4,z3,z2,z1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(11,12))

        CALL dx1x2(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(1,4))
        CALL dx1x2(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(2,5))
        CALL dx1x2(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(3,6))
        CALL dx1x2(x4,x3,x2,x1,y4,y3,y2,y1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(7,10))
        CALL dx1x2(y4,y3,y2,y1,x4,x3,x2,x1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(8,11))
        CALL dx1x2(z4,z3,z2,z1,y4,y3,y2,y1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(9,12))

        CALL dx1y2(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(1,5))
        CALL dx1y2(x1,x2,x3,x4,z1,z2,z3,z4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(1,6))
        CALL dx1y2(y1,y2,y3,y4,z1,z2,z3,z4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(2,6))
        CALL dx1y2(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(2,4))
        CALL dx1y2(z1,z2,z3,z4,x1,x2,x3,x4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(3,4))
        CALL dx1y2(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(3,5))
        CALL dx1y2(x4,x3,x2,x1,y4,y3,y2,y1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(7,11))
        CALL dx1y2(x4,x3,x2,x1,z4,z3,z2,z1,y4,y3,y2,y1,
     *          tors%k,tors%eqval,thess(7,12))
        CALL dx1y2(y4,y3,y2,y1,x4,x3,x2,x1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(8,10))
        CALL dx1y2(y4,y3,y2,y1,z4,z3,z2,z1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(8,12))
        CALL dx1y2(z4,z3,z2,z1,x4,x3,x2,x1,y4,y3,y2,y1,
     *          tors%k,tors%eqval,thess(9,10))
        CALL dx1y2(z4,z3,z2,z1,y4,y3,y2,y1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(9,11))

        CALL dx1x3(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(1,7))
        CALL dx1x3(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(2,8))
        CALL dx1x3(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(3,9))
        CALL dx1x3(x4,x3,x2,x1,y4,y3,y2,y1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(4,10))
        CALL dx1x3(y4,y3,y2,y1,x4,x3,x2,x1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(5,11))
        CALL dx1x3(z4,z3,z2,z1,y4,y3,y2,y1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(6,12))

        CALL dx1y3(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(1,8))
        CALL dx1y3(x1,x2,x3,x4,z1,z2,z3,z4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(1,9))
        CALL dx1y3(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(2,7))
        CALL dx1y3(y1,y2,y3,y4,z1,z2,z3,z4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(2,9))
        CALL dx1y3(z1,z2,z3,z4,x1,x2,x3,x4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(3,7))
        CALL dx1y3(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(3,8))
        CALL dx1y3(x4,x3,x2,x1,y4,y3,y2,y1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(4,11))
        CALL dx1y3(x4,x3,x2,x1,z4,z3,z2,z1,y4,y3,y2,y1,
     *          tors%k,tors%eqval,thess(4,12))
        CALL dx1y3(y4,y3,y2,y1,x4,x3,x2,x1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(5,10))
        CALL dx1y3(y4,y3,y2,y1,z4,z3,z2,z1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(5,12))
        CALL dx1y3(z4,z3,z2,z1,x4,x3,x2,x1,y4,y3,y2,y1,
     *          tors%k,tors%eqval,thess(6,10))
        CALL dx1y3(z4,z3,z2,z1,y4,y3,y2,y1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(6,11))

        CALL dx1x4(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(1,10))
        CALL dx1x4(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(2,11))
        CALL dx1x4(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(3,12))

        CALL dx1y4(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(1,11))
        CALL dx1y4(x1,x2,x3,x4,z1,z2,z3,z4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(1,12))
        CALL dx1y4(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(2,10))
        CALL dx1y4(y1,y2,y3,y4,z1,z2,z3,z4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(2,12))
        CALL dx1y4(z1,z2,z3,z4,x1,x2,x3,x4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(3,10))
        CALL dx1y4(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(3,11))

        CALL dx2x2(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(4,4))
        CALL dx2x2(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(5,5))
        CALL dx2x2(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(6,6))
        CALL dx2x2(x4,x3,x2,x1,y4,y3,y2,y1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(7,7))
        CALL dx2x2(y4,y3,y2,y1,x4,x3,x2,x1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(8,8))
        CALL dx2x2(z4,z3,z2,z1,y4,y3,y2,y1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(9,9))

        CALL dx2y2(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(4,5))
        CALL dx2y2(x1,x2,x3,x4,z1,z2,z3,z4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(4,6))
        CALL dx2y2(y1,y2,y3,y4,z1,z2,z3,z4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(5,6))
        CALL dx2y2(x4,x3,x2,x1,y4,y3,y2,y1,z4,z3,z2,z1,
     *          tors%k,tors%eqval,thess(7,8))
        CALL dx2y2(x4,x3,x2,x1,z4,z3,z2,z1,y4,y3,y2,y1,
     *          tors%k,tors%eqval,thess(7,9))
        CALL dx2y2(y4,y3,y2,y1,z4,z3,z2,z1,x4,x3,x2,x1,
     *          tors%k,tors%eqval,thess(8,9))

        CALL dx2x3(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(4,7))
        CALL dx2x3(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(5,8))
        CALL dx2x3(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(6,9))

        CALL dx2y3(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(4,8))
        CALL dx2y3(x1,x2,x3,x4,z1,z2,z3,z4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(4,9))
        CALL dx2y3(y1,y2,y3,y4,x1,x2,x3,x4,z1,z2,z3,z4,
     *          tors%k,tors%eqval,thess(5,7))
        CALL dx2y3(y1,y2,y3,y4,z1,z2,z3,z4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(5,9))
        CALL dx2y3(z1,z2,z3,z4,x1,x2,x3,x4,y1,y2,y3,y4,
     *          tors%k,tors%eqval,thess(6,7))
        CALL dx2y3(z1,z2,z3,z4,y1,y2,y3,y4,x1,x2,x3,x4,
     *          tors%k,tors%eqval,thess(6,8))
c
c  Apply symmetry to thess
c
      do 27 i=1, 12
         do 28 j=1, i
            thess(i,j) = thess(j,i)
  28     continue
  27  continue
c
c  Add rhess, ahess, and thess to imohchess
c
      do 30 i=1, 2
       do 40 j=1, 2
        do 50 k=0, 2
         do 60 l=0, 2
            imohchess(bond%atoms(i)*3-l,bond%atoms(j)*3-k) =
     *         imohchess(bond%atoms(i)*3-l,bond%atoms(j)*3-k) +
     *         rhess(3*i-l,3*j-k)
  60     continue
  50    continue
  40   continue
  30  continue

      do 70 i=1, 3
       do 80 j=1, 3
        do 90 k=0, 2
         do 100 l=0, 2
            imohchess(angle%atoms(i)*3-l,angle%atoms(j)*3-k) =
     *         imohchess(angle%atoms(i)*3-l,angle%atoms(j)*3-k) +
     *         ahess(3*i-l,3*j-k)
 100     continue
  90    continue
  80   continue
  70  continue

      do 110 i=1,4
       do 120 j=1,4
        do 130 k=0,2
         do 140 l=0,2
            imohchess(tors%atoms(i)*3-l,tors%atoms(j)*3-k) =
     *         imohchess(tors%atoms(i)*3-l,tors%atoms(j)*3-k) +
     *         thess(3*i-l,3*j-k)
 140     continue
 130    continue
 120   continue
 110  continue

      return
      end
c
c******************************************************************************
c  D2XX
c******************************************************************************
c
      subroutine d2xx(x1,x2,y1,y2,z1,z2,k1,r0,dxx)
c
c     Subroutine d2xx
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c  
c     Variables defined here:
c
      implicit none

      double precision  dxx,x1,x2,y1,y2,z1,z2,k1,r0

c      dxx=(-k1*(x1-x2)**2*(-r0+Sqrt((x1-x2)**2+(y1-y2)**2+(z1-
c     *   z2)**2)))/
c     *   ((x1 - x2)**2 + (y1 - y2)**2+(z1-z2)**2)**1.5 + 
c     *  (2*k1*(x1 - x2)**2)/((x1 - x2)**2+(y1-y2)**2+(z1-z2)**2)+ 
c     *  (2*k1*(-r0 + Sqrt((x1 - x2)**2+(y1-y2)**2+(z1-z2)**2)))/
c     *   Sqrt((x1 - x2)**2 + (y1 - y2)**2+(z1 - z2)**2)

c     new 2nd deriv.

       dxx=  -((k1*(x1 - x2)**2*
     -       (-r0 + Sqrt((x1 - x2)**2 + (y1 - y2)**2 + 
     -           (z1 - z2)**2)))/
     -     ((x1 - x2)**2 + (y1 - y2)**2 + (z1 - z2)**2)**1.5
     -     ) + (k1*(x1 - x2)**2)/
     -   ((x1 - x2)**2 + (y1 - y2)**2 + (z1 - z2)**2) + 
     -  (k1*(-r0 + Sqrt((x1 - x2)**2 + (y1 - y2)**2 + 
     -         (z1 - z2)**2)))/
     -   Sqrt((x1 - x2)**2 + (y1 - y2)**2 + (z1 - z2)**2)



      return
      end
c
c******************************************************************************
c  D2XY
c******************************************************************************
c
      subroutine d2xy(x1,x2,y1,y2,z1,z2,k1,r0,dxy)
c
c     Subroutine d2xy
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c        
c     Called by:  hhess
c     Calls:
c     
c     Variables defined here:
c
      implicit none
 
      double precision  dxy,x1,x2,y1,y2,z1,z2,k1,r0
     
c      dxy= (-k1*(x1 - x2)*(y1 - y2)*(-r0 + 
c     *       Sqrt((x1 - x2)**2 + (y1 - y2)**2 + (z1 - z2)**2)))/
c     *   ((x1 - x2)**2 + (y1 - y2)**2 + (z1 - z2)**2)**1.5 + 
c     *  (k1*(x1-x2)*(y1-y2))/((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)



      return
      end   
c
c******************************************************************************
c  DAX1X1
c******************************************************************************
c  
      subroutine dax1x1(x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,
     *  thetanot,ddxx)
c
c     Subroutine dax1x1
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c     
c     Called by:  hhess
c     Calls:
c     
c     Variables defined here:
c     
      implicit none
 
      double precision  x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,ddxx,
     *  thetanot

      ddxx=(k2*((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**2)/
     *  (1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))- 
     *  (k2*((-2*(x1-x2)*(-x2+x3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  (3*(x1-x2)**2*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  Sqrt(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-
     *  z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))+
     *  (k2*((-2*(-x2+x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)
     *  +(z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+  
     *  (2*(x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2* 
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*   
     *  ((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  (2.*(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DAX1Y1
c******************************************************************************
c
      subroutine dax1y1(x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,
     *  thetanot,ddxx)
c
c     Subroutine dax1y1
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c    
c     Called by:  hhess
c     Calls:
c    
c     Variables defined here:
c    
      implicit none
     
      double precision  x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,ddxx,thetanot

      ddxx=(k2*((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  ((-y2+y3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((y1-y2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))))/
     *  (1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-
     *  z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))-
     *  (k2*(-(((-x2+x3)*(y1-y2))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))-
     *  ((x1-x2)*(-y2+y3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  (3*(x1-x2)*(y1-y2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  Sqrt(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))+   
     *  (k2*((-2*(-y2+y3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3
     *  )+(z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  (2*(y1-y2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(
     *  z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  ((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2
     *  )*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  (2.*(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DAX1X2
c******************************************************************************
c
      subroutine dax1x2(x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,
     +  thetanot,ddxx)
c
c     Subroutine dax1x2
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,ddxx,thetanot

      ddxx=(k2*((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2
     *  )*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (((-x2+x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  (-x1+2*x2-x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*   
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*   
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))))/
     *  (1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-z2+
     *  z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))-
     *  (k2*((-x2+x3)**2/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)- 
     *  ((x1-x2)*(-x2+x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)-
     *  ((x1-x2)*(-x1+2*x2-x3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((x1-x2)*(-x2+x3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  1/(Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  (3*(x1-x2)**2*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*    
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  Sqrt(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))+
     *  (k2*((-2*(-x2+x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+
     *  y3)+(z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**2)-
     *  (2*(-x1+2*x2-x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  (2*(x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-
     *  z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))* 
     *  ((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*   
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  (2.*(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DAX1Y2
c******************************************************************************
c
      subroutine dax1y2(x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,
     *  thetanot,ddxx)
c
c     Subroutine dax1y2
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,ddxx,thetanot

      ddxx=(k2*((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (((-y2+y3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  (-y1+2*y2-y3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*   
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((y1-y2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-
     *  z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*   
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))))/
     *  (1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-
     *  z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))-
     *  (k2*(((-x2+x3)*(-y2+y3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)- 
     *  ((x1-x2)*(-y2+y3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  ((-x2+x3)*(y1-y2))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*(-y1+2*y2-y3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  (3*(x1-x2)*(y1-y2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  Sqrt(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))+
     *  (k2*((-2*(-y2+y3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+
     *  y3)+(z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**2)-
     *  (2*(-y1+2*y2-y3)*((x1-x2)*(-x2+x3)+(y1-y2)*
     *  (-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  (2*(y1-y2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2*  
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  ((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+ 
     *  (z1-z2)*(-z2+z3))/ 
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  (2.*(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2
     *  )*(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DAX1X3
c******************************************************************************
c
      subroutine dax1x3(x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,
     *  thetanot,ddxx)
c
c     Subroutine dax1x3
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,ddxx,thetanot

      ddxx=(k2*(-(((-x2+x3)*((x1-x2)*(-x2+x3)+(y1-y2)*
     *  (-y2+y3)+(z1-z2)*(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5))+
     *  (x1-x2)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  ((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*  
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))))/
     *  (1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-
     *  z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))-
     *  (k2*(-((-x2+x3)**2/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5))+ 
     *  ((x1-x2)*(-x2+x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)-
     *  (x1-x2)**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  1/(Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  Sqrt(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))+
     *  (k2*((2*(-x2+x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+
     *  y3)+(z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**2)- 
     *  (2*(x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  ((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-
     *  z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*  
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/ 
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  (2.*(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*
     *  (-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DAX1Y3
c******************************************************************************
c
      subroutine dax1y3(x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,
     *  thetanot,ddxx)
c
c     Subroutine dax1y3
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,ddxx,thetanot

      ddxx=(k2*(-(((-y2+y3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-
     *  y2+y3)+(z1-z2)*(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5))+
     *  (y1-y2)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*   
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  ((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*  
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))))/
     *  (1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3
     *  ))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))-
     *  (k2*(-(((-x2+x3)*(-y2+y3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5))+ 
     *  ((x1-x2)*(-y2+y3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)-
     *  ((x1-x2)*(y1-y2))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  Sqrt(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))+
     *  (k2*((2*(-y2+y3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)
     *  +(z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**2)-
     *  (2*(y1-y2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(
     *  z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  ((-x2+x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-
     *  z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  (2.*(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DAX2X2
c******************************************************************************
c
      subroutine dax2x2(x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,
     *  thetanot,ddxx)
c
c     Subroutine dax2x2
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,ddxx,thetanot

      ddxx=(k2*(((-x2+x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+
     *  y3)+(z1-z2)*(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  (-x1+2*x2-x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*  
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-
     *  z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**2)/
     *  (1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-
     *  z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))-
     *  (k2*((3*(-x2+x3)**2*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**2.5)+
     *  (2*(-x1+2*x2-x3)*(-x2+x3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  (2*(x1-x2)*(-x2+x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)-
     *  ((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  (2*(x1-x2)*(-x1+2*x2-x3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  2/(Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  (3*(x1-x2)**2*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2.5* 
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  ((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  Sqrt(1-((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+(z1-z2)
     *  *(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))+
     *  (k2*((-2*(-x2+x3)*((x1-x2)*(-x2+x3
     *  )+(y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**2)-
     *  (2*(-x1+2*x2-x3)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  (2*(x1-x2)*((x1-x2)*(-x2+x3)+
     *  (y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))* 
     *  (((-x2+x3)*((x1-x2)*(-x2+x3)+
     *  (y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*  
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  (-x1+2*x2-x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2)*(-y2
     *  +y3)+(z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  (2.*(1-((x1-x2)*(-x2+x3)+(y1-y2)*
     *  (-y2+y3)+(z1-z2)*(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DAX2Y2
c******************************************************************************
c
      subroutine dax2y2(x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,
     *  thetanot,ddxx)
c
c     Subroutine dax2y2
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,y1,y2,y3,z1,z2,z3,k2,ddxx,thetanot

      ddxx=(k2*(((-x2+x3)*((x1-x2)*(-x2+x3)+
     *  (y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  (-x1+2*x2-x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*   
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+
     *  (y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5* 
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (((-y2+y3)*((x1-x2)*(-x2+x3)+
     *  (y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  (-y1+2*y2-y3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((y1-y2)*((x1-x2)*(-x2+x3)+(y1-y2
     *  )*(-y2+y3)+(z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))))/
     *  (1-((x1-x2)*(-x2+x3)+(y1-y2)*
     *  (-y2+y3)+(z1-z2)*(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))-
     *  (k2*((3*(-x2+x3)*(-y2+y3)*((x1-x2)*
     *  (-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**2.5)+
     *  ((-x2+x3)*(-y1+2*y2-y3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  ((-x1+2*x2-x3)*(-y2+y3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  ((-x2+x3)*(y1-y2)*((x1-x2)*(-x2+x3)+
     *  (y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*   
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  ((x1-x2)*(-y2+y3)*(
     *  (x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  ((-x1+2*x2-x3)*(y1-y2))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((x1-x2)*(-y1+2*y2-y3))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  (3*(x1-x2)*(y1-y2)*
     *  ((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-x2)*
     *  (-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  Sqrt(1-((x1-x2)*(-x2+x3)+(y1-y2)
     *  *(-y2+y3)+(z1-z2)*(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))+
     *  (k2*((-2*(-y2+y3)*((x1-x2)*(-x2+x3)+
     *  (y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**2)-  
     *  (2*(-y1+2*y2-y3)
     *  *((x1-x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+ 
     *  (z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))-
     *  (2*(y1-y2)*((x1-x2)*(-x2+x3)+(y1-y2
     *  )*(-y2+y3)+(z1-z2)*(-z2+z3))**2)/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**2*  
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (((-x2+x3)*((x1-x2)*(-x2+x3)+
     *  (y1-y2)*(-y2+y3)+(z1-z2)*(-z2+z3)))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)**1.5)+
     *  (-x1+2*x2-x3)/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)* 
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2))+
     *  ((x1-x2)*((x1-x2)*(-x2+x3)+(y1-y2
     *  )*(-y2+y3)+(z1-z2)*(-z2+z3)))/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)**1.5*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))*
     *  (-thetanot+ACos(((x1-
     *  x2)*(-x2+x3)+(y1-y2)*(-y2+y3)+
     *  (z1-z2)*(-z2+z3))/
     *  (Sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  Sqrt((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))))/
     *  (2.*(1-((x1-x2)*(-x2+x3)+(y1-y2)*
     *  (-y2+y3)+(z1-z2)*(-z2+z3))**2/
     *  (((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)*
     *  ((-x2+x3)**2+(-y2+y3)**2+(-z2+z3)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DX1X1
c******************************************************************************
c
      subroutine dx1x1(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx1x1
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12

        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))**2)/
     * (1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))+
     * (k3*((-2*((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+((2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12))**2)/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**2*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))*(((-y2+y3)*(T1+T2)+
     * (z2-z3)*(T3-T4))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-((2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * (2*(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))**1.5)-(k3*(-(((2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((-y2+y3)*(T1+T2)+
     * (z2-z3)*(T3-T4)))/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))+(3*(2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))**2*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (4*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**2.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(-y2+y3)**2+2*(z2-z3)**2)*((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))))/Sqrt(1-((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))

      return
      end
c
c******************************************************************************
c  DX1Y1
c******************************************************************************
c
      subroutine dx1y1(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx1y1
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers 
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12

        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(-((2*(x2-x3)*(T5+T6)+
     * 2*(T7+T8)*(-z2+z3))*((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12)))/(2*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))+((x2-x3)*(T1+T2)+
     * (-z2+z3)*(T11+T12))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))))/(1-((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))+(k3*(((2*(x2-x3)*(T5+T6)+
     * 2*(T7+T8)*(-z2+z3))*((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12))**2)/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**2*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-(2*((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * ((x2-x3)*(T1+T2)+(-z2+z3)*(T11+T12)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))*
     * (((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(-phinot+ACOS(((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * (2*(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))**1.5)-(k3*(-((2*(x2-x3)*(T5+T6)+
     * 2*(T7+T8)*(-z2+z3))*((-y2+y3)*(T1+T2)+
     * (z2-z3)*(T3-T4)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-((x2-x3)*(-y2+y3)*((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * (3*(2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * (2*(x2-x3)*(T5+T6)+2*(T7+T8)*(-z2+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(4*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**2.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-((2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((x2-x3)*(T1+T2)+
     * (-z2+z3)*(T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(-phinot+ACOS(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * Sqrt(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))

      return
      end
c
c******************************************************************************
c  DX1X2
c******************************************************************************
c
      subroutine dx1x2(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx1x2
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
     
        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(-((2*(T5+T6)*(y1-y3)+
     * 2*(T9-T10)*(-z1+z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * ((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+(-z1+z3)*(T3-T4)+
     * (T9-T10)*(z3-z4))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-(((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12))*(2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4)))/(2*Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5)))/(1-((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))+
     * (k3*(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(((2*(T5+T6)*(y1-y3)+
     * 2*(T9-T10)*(-z1+z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2)/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**2*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * (2*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))*((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+
     * (-z1+z3)*(T3-T4)+(T9-T10)*(z3-z4)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2*(2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4)))/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**2))*(-phinot+ACOS(((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * (2*(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))**1.5)-
     * (k3*(-((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * (3*(2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * (2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(4*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**2.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-
     * ((2*(y1-y3)*(-y2+y3)+2*(z2-z3)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-((2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((y1-y3)*(T1+T2)+
     * (T5+T6)*(-y3+y4)+(-z1+z3)*(T3-T4)+(T9-T10)*(z3-z4)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * ((-y2+y3)*(-y3+y4)+(z2-z3)*(z3-z4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * (((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))*
     * (2*(T1+T2)*(-y3+y4)+2*(T3-T4)*(z3-z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5)+
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))*(2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4)))/(4*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * Sqrt(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))

      return
      end
c
c******************************************************************************
c  DX1Y2
c******************************************************************************
c
      subroutine dx1y2(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx1y2
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers  
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
     
        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(-((2*(-x1+x3)*(T5+T6)+
     * 2*(T7+T8)*(z1-z3))*((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12)))/(2*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))+((x3-x4)*(T5+T6)+
     * (-x1+x3)*(T1+T2)+(z1-z3)*(T11+T12)+
     * (T7+T8)*(-z3+z4))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-(((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12))*(2*(x3-x4)*(T1+T2)+
     * 2*(T11+T12)*(-z3+z4)))/(2*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5)))/(1-((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))+
     * (k3*(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(((2*(-x1+x3)*(T5+T6)+
     * 2*(T7+T8)*(z1-z3))*((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12))**2)/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**2*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-(2*((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * ((x3-x4)*(T5+T6)+(-x1+x3)*(T1+T2)+
     * (z1-z3)*(T11+T12)+(T7+T8)*(-z3+z4)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2*(2*(x3-x4)*(T1+T2)+
     * 2*(T11+T12)*(-z3+z4)))/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**2))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))))/(2*(1-((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))**1.5)-
     * (k3*(((x2-x4)*(-y2+y3)+(x3-x4)*(-y2+y3)-T2)/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(-x1+x3)*(T5+T6)+2*(T7+T8)*(z1-z3))*
     * ((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((-2*(T5+T6)+2*(-x1+x3)*(-y2+y3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+(3*(2*(-x1+x3)*(T5+T6)+
     * 2*(T7+T8)*(z1-z3))*(2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (4*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**2.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((x3-x4)*(T5+T6)+(-x1+x3)*(T1+T2)+
     * (z1-z3)*(T11+T12)+(T7+T8)*(-z3+z4)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * (((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))*
     * (2*(x3-x4)*(T1+T2)+2*(T11+T12)*(-z3+z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5)+((2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * (2*(x3-x4)*(T1+T2)+2*(T11+T12)*(-z3+z4)))/
     * (4*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))))/Sqrt(1-((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))

      return
      end
c
c******************************************************************************
c  DX1X3
c******************************************************************************
c
      subroutine dx1x3(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx1x3
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers   
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
     
        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(-((2*(-y1+y2)*(T5+T6)+
     * 2*(z1-z2)*(T9-T10))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * ((-y1+y2)*(T1+T2)+(T5+T6)*(y2-y4)+
     * (z1-z2)*(T3-T4)+(T9-T10)*(-z2+z4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*(2*(T1+T2)*(y2-y4)+
     * 2*(T3-T4)*(-z2+z4)))/(2*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5)))/
     * (1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))+
     * (k3*(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12)))/(2*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))*(((2*(-y1+y2)*(T5+T6)+
     * 2*(z1-z2)*(T9-T10))*((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12))**2)/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**2*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-(2*((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * ((-y1+y2)*(T1+T2)+(T5+T6)*(y2-y4)+
     * (z1-z2)*(T3-T4)+(T9-T10)*(-z2+z4)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2*
     * (2*(T1+T2)*(y2-y4)+2*(T3-T4)*(-z2+z4)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**2))*(-phinot+ACOS(((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))))/(2*(1-((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))**1.5)-
     * (k3*(-((2*(-y1+y2)*(T5+T6)+2*(z1-z2)*(T9-T10))*
     * ((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(-y1+y2)*(-y2+y3)+2*(z1-z2)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+(3*(2*(-y1+y2)*(T5+T6)+
     * 2*(z1-z2)*(T9-T10))*(2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (4*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**2.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((-y1+y2)*(T1+T2)+(T5+T6)*(y2-y4)+
     * (z1-z2)*(T3-T4)+(T9-T10)*(-z2+z4)))/
     * (2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))+
     * ((-y2+y3)*(y2-y4)+(z2-z3)*(-z2+z4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-
     * (((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))*
     * (2*(T1+T2)*(y2-y4)+2*(T3-T4)*(-z2+z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5)+
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*(2*(T1+T2)*(y2-y4)+
     * 2*(T3-T4)*(-z2+z4)))/(4*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*
     * ((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5))*(-phinot+ACOS(((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))))/Sqrt(1-((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))

      return
      end
c
c******************************************************************************
c  DX1Y3
c******************************************************************************
c
      subroutine dx1y3(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx1y3
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12

        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1) 
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(-((2*(x1-x2)*(T5+T6)+
     * 2*(-z1+z2)*(T7+T8))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * ((-x2+x4)*(T5+T6)+(x1-x2)*(T1+T2)+
     * (-z1+z2)*(T11+T12)+(T7+T8)*(z2-z4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*(2*(-x2+x4)*(T1+T2)+
     * 2*(T11+T12)*(z2-z4)))/(2*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5)))/
     * (1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))+
     * (k3*(((-y2+y3)*(T1+T2)+
     * (z2-z3)*(T3-T4))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-((2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))*
     * (((2*(x1-x2)*(T5+T6)+2*(-z1+z2)*(T7+T8))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2)/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**2*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-(2*((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * ((-x2+x4)*(T5+T6)+(x1-x2)*(T1+T2)+
     * (-z1+z2)*(T11+T12)+(T7+T8)*(z2-z4)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2*(2*(-x2+x4)*(T1+T2)+
     * 2*(T11+T12)*(z2-z4)))/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**2))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))))/(2*(1-((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))**1.5)-
     * (k3*((T1+(-x2+x4)*(-y2+y3)+T2)/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-
     * ((2*(x1-x2)*(T5+T6)+2*(-z1+z2)*(T7+T8))*
     * ((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)+2*(x1-x2)*(-y2+y3))*((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+(3*(2*(x1-x2)*(T5+T6)+
     * 2*(-z1+z2)*(T7+T8))*(2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (4*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**2.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((-x2+x4)*(T5+T6)+(x1-x2)*(T1+T2)+
     * (-z1+z2)*(T11+T12)+(T7+T8)*(z2-z4)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * (((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))*
     * (2*(-x2+x4)*(T1+T2)+2*(T11+T12)*(z2-z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5)+
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*(2*(-x2+x4)*(T1+T2)+
     * 2*(T11+T12)*(z2-z4)))/(4*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))))/Sqrt(1-((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))

      return
      end
c
c******************************************************************************
c  DX1X4
c******************************************************************************
c
      subroutine dx1x4(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx1x4 
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none   
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
     
        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4) 
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(-((2*(-y2+y3)*(T1+T2)+2*(z2-z3)*(T3-T4))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5)+((T5+T6)*(-y2+y3)+
     * (T9-T10)*(z2-z3))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))*(((-y2+y3)*(T1+T2)+
     * (z2-z3)*(T3-T4))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-((2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12)))/(2*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))))/(1-((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))-(k3*(-(((-y2+y3)*(T1+T2)+
     * (z2-z3)*(T3-T4))*(2*(-y2+y3)*(T1+T2)+
     * 2*(z2-z3)*(T3-T4)))/(2*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5)+
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * (2*(-y2+y3)*(T1+T2)+2*(z2-z3)*(T3-T4))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12)))/(4*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5)-
     * (((T5+T6)*(-y2+y3)+(T9-T10)*(z2-z3))*
     * (2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3)))/
     * (2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))+
     * ((-y2+y3)**2+(z2-z3)**2)/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * Sqrt(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))+
     * (k3*(((2*(-y2+y3)*(T1+T2)+2*(z2-z3)*(T3-T4))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2)/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**2)-(2*((T5+T6)*(-y2+y3)+
     * (T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))*
     * (((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))))/(2*(1-((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DX1Y4
c******************************************************************************
c
      subroutine dx1y4(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx1y4
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
     
        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(-(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*(2*(x2-x3)*(T1+T2)+
     * 2*(-z2+z3)*(T11+T12)))/(2*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5)+
     * ((x2-x3)*(T5+T6)+(T7+T8)*(-z2+z3))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))*
     * (((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))))/(1-((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))-
     * (k3*(-(((-y2+y3)*(T1+T2)+(z2-z3)*(T3-T4))*
     * (2*(x2-x3)*(T1+T2)+2*(-z2+z3)*(T11+T12)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5)+
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))*(2*(x2-x3)*(T1+T2)+
     * 2*(-z2+z3)*(T11+T12)))/(4*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5)+((x2-x3)*(-y2+y3))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(-y2+y3)+2*(T9-T10)*(z2-z3))*
     * ((x2-x3)*(T5+T6)+(T7+T8)*(-z2+z3)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * Sqrt(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))+(k3*((((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2*(2*(x2-x3)*(T1+T2)+
     * 2*(-z2+z3)*(T11+T12)))/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**2)-
     * (2*((x2-x3)*(T5+T6)+(T7+T8)*(-z2+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(((-y2+y3)*(T1+T2)+
     * (z2-z3)*(T3-T4))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-((2*(T5+T6)*(-y2+y3)+
     * 2*(T9-T10)*(z2-z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))*(-phinot+ACOS(((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * (2*(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))**1.5)

      return
      end
c
c******************************************************************************
c  DX2X2
c******************************************************************************
c
      subroutine dx2x2(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx2x2
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
     
        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)  
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(-((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+
     * (-z1+z3)*(T3-T4)+(T9-T10)*(z3-z4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))*(2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4)))/(2*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5))**2)/
     * (1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))+(k3*(((2*(T5+T6)*(y1-y3)+
     * 2*(T9-T10)*(-z1+z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2)/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**2*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * (2*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*((y1-y3)*(T1+T2)+
     * (T5+T6)*(-y3+y4)+(-z1+z3)*(T3-T4)+
     * (T9-T10)*(z3-z4)))/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2*(2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4)))/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**2))*(-((2*(T5+T6)*(y1-y3)+
     * 2*(T9-T10)*(-z1+z3))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * ((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+
     * (-z1+z3)*(T3-T4)+(T9-T10)*(z3-z4))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * (2*(T1+T2)*(-y3+y4)+2*(T3-T4)*(z3-z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))))/(2*(1-((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))**1.5)-
     * (k3*((3*(2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))**2*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12)))/(4*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**2.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-
     * ((2*(y1-y3)**2+2*(-z1+z3)**2)*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * ((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+(-z1+z3)*(T3-T4)+
     * (T9-T10)*(z3-z4)))/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+
     * (2*(y1-y3)*(-y3+y4)+2*(-z1+z3)*(z3-z4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * ((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))*(2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5)-(((y1-y3)*(T1+T2)+
     * (T5+T6)*(-y3+y4)+(-z1+z3)*(T3-T4)+
     * (T9-T10)*(z3-z4))*(2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4)))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5)+
     * (3*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*(2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4))**2)/(4*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**2.5)-(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))*(2*(-y3+y4)**2+2*(z3-z4)**2))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * Sqrt(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))

      return
      end
c
c******************************************************************************
c  DX2Y2
c******************************************************************************
c
      subroutine dx2y2(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx2y2
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none
     
      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
     
        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(-((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))+((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+
     * (-z1+z3)*(T3-T4)+(T9-T10)*(z3-z4))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*(2*(T1+T2)*(-y3+y4)+2*(T3-T4)*(z3-z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5))*(-((2*(-x1+x3)*(T5+T6)+
     * 2*(T7+T8)*(z1-z3))*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+((x3-x4)*(T5+T6)+
     * (-x1+x3)*(T1+T2)+(z1-z3)*(T11+T12)+(T7+T8)*(-z3+z4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-(((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12))*(2*(x3-x4)*(T1+T2)+2*(T11+T12)*
     * (-z3+z4)))/(2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5)))/(1-((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))+(k3*(-((2*(T5+T6)*(y1-y3)+2*(T9-T10)*
     * (-z1+z3))*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+((y1-y3)*(T1+T2)+
     * (T5+T6)*(-y3+y4)+(-z1+z3)*(T3-T4)+(T9-T10)*(z3-z4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*(2*(T1+T2)*(-y3+y4)+2*(T3-T4)*(z3-z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5))*(((2*(-x1+x3)*(T5+T6)+
     * 2*(T7+T8)*(z1-z3))*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2)/(((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**2*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-(2*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*((x3-x4)*(T5+T6)+
     * (-x1+x3)*(T1+T2)+(z1-z3)*(T11+T12)+(T7+T8)*(-z3+z4)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2*(2*(x3-x4)*(T1+T2)+2*(T11+T12)*(-z3+z4)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**2))*(-phinot+ACOS(((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)))))/(2*(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))**1.5)-(k3*(-(((x3-x4)*
     * (-y3+y4)*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5))+((x3-x4)*(y1-y3)+
     * (-x1+x3)*(-y3+y4))/(Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-((-x1+x3)*(y1-y3)*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))+(3*(2*(-x1+x3)*(T5+T6)+2*(T7+T8)*
     * (z1-z3))*(2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/(4*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**2.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-((2*(-x1+x3)*(T5+T6)+2*(T7+T8)*(z1-z3))*
     * ((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+(-z1+z3)*(T3-T4)+(T9-T10)*
     * (z3-z4)))/(2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+((2*(-x1+x3)*(T5+T6)+
     * 2*(T7+T8)*(z1-z3))*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))*(2*(T1+T2)*(-y3+y4)+2*(T3-T4)*(z3-z4)))/
     * (4*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5)-((2*(T5+T6)*(y1-y3)+2*(T9-T10)*
     * (-z1+z3))*((x3-x4)*(T5+T6)+(-x1+x3)*(T1+T2)+(z1-z3)*(T11+T12)+
     * (T7+T8)*(-z3+z4)))/(2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-((2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4))*((x3-x4)*(T5+T6)+(-x1+x3)*(T1+T2)+
     * (z1-z3)*(T11+T12)+(T7+T8)*(-z3+z4)))/(2*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5)+((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * (2*(x3-x4)*(T1+T2)+2*(T11+T12)*(-z3+z4)))/(4*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5)-(((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+
     * (-z1+z3)*(T3-T4)+(T9-T10)*(z3-z4))*(2*(x3-x4)*(T1+T2)+
     * 2*(T11+T12)*(-z3+z4)))/(2*Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5)+
     * (3*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * (2*(T1+T2)*(-y3+y4)+2*(T3-T4)*(z3-z4))*(2*(x3-x4)*(T1+T2)+
     * 2*(T11+T12)*(-z3+z4)))/(4*Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**2.5))*
     * (-phinot+ACOS(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))/(Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * Sqrt(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))

      return
      end
c
c******************************************************************************
c  DX2X3
c******************************************************************************
c
      subroutine dx2x3(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx2x3
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none

      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12

        t1 = -(x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)

      ddxx=(k3*(-((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))+((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+
     * (-z1+z3)*(T3-T4)+(T9-T10)*(z3-z4))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))-(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))*(2*(T1+T2)*(-y3+y4)+2*(T3-T4)*(z3-z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5))*(-((2*(-y1+y2)*(T5+T6)+
     * 2*(z1-z2)*(T9-T10))*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12)))/(2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*
     * Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+((-y1+y2)*(T1+T2)+
     * (T5+T6)*(y2-y4)+(z1-z2)*(T3-T4)+(T9-T10)*(-z2+z4))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+
     * (T7+T8)*(T11+T12))*(2*(T1+T2)*(y2-y4)+2*(T3-T4)*(-z2+z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5)))/(1-((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))+
     * (k3*(-((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/(2*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+(-z1+z3)*
     * (T3-T4)+(T9-T10)*(z3-z4))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * (2*(T1+T2)*(-y3+y4)+2*(T3-T4)*(z3-z4)))/(2*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5))*(((2*(-y1+y2)*(T5+T6)+2*(z1-z2)*
     * (T9-T10))*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2)/(((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**2*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))-(2*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*((-y1+y2)*(T1+T2)+
     * (T5+T6)*(y2-y4)+(z1-z2)*(T3-T4)+(T9-T10)*(-z2+z4)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+(((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2*(2*(T1+T2)*(y2-y4)+2*(T3-T4)*(-z2+z4)))/
     * (((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**2))*(-phinot+ACOS(((T5+T6)*(T1+T2)+(T9-T10)*
     * (T3-T4)+(T7+T8)*(T11+T12))/(Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))))/
     * (2*(1-((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*
     * (T11+T12))**2/(((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*
     * ((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)))**1.5)-
     * (k3*(-((2*(-y1+y2)*(y1-y3)+2*(z1-z2)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))+(3*(2*(-y1+y2)*(T5+T6)+
     * 2*(z1-z2)*(T9-T10))*(2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12)))/
     * (4*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**2.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-((2*(-y1+y2)*(T5+T6)+2*(z1-z2)*
     * (T9-T10))*((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+(-z1+z3)*
     * (T3-T4)+(T9-T10)*(z3-z4)))/(2*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*Sqrt((T1+T2)**2+(T3-T4)**2+(T11+T12)**2))+
     * ((2*(-y1+y2)*(T5+T6)+2*(z1-z2)*(T9-T10))*((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*(2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4)))/(4*((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)**1.5*((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5)-
     * ((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*((-y1+y2)*(T1+T2)+
     * (T5+T6)*(y2-y4)+(z1-z2)*(T3-T4)+(T9-T10)*(-z2+z4)))/
     * (2*((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)**1.5*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2))-((2*(T1+T2)*(-y3+y4)+
     * 2*(T3-T4)*(z3-z4))*((-y1+y2)*(T1+T2)+(T5+T6)*(y2-y4)+
     * (z1-z2)*(T3-T4)+(T9-T10)*(-z2+z4)))/(2*Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5)+((y1-y3)*(y2-y4)+(-y1+y2)*(-y3+y4)+
     * (z1-z2)*(z3-z4)+(-z1+z3)*(-z2+z4))/(Sqrt((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2))+((2*(T5+T6)*(y1-y3)+2*(T9-T10)*(-z1+z3))*
     * ((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * (2*(T1+T2)*(y2-y4)+2*(T3-T4)*(-z2+z4)))/(4*((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)**1.5*((T1+T2)**2+(T3-T4)**2+
     * (T11+T12)**2)**1.5)-(((y1-y3)*(T1+T2)+(T5+T6)*(-y3+y4)+
     * (-z1+z3)*(T3-T4)+(T9-T10)*(z3-z4))*(2*(T1+T2)*(y2-y4)+
     * 2*(T3-T4)*(-z2+z4)))/(2*Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**1.5)+
     * (3*((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * (2*(T1+T2)*(-y3+y4)+2*(T3-T4)*(z3-z4))*(2*(T1+T2)*(y2-y4)+
     * 2*(T3-T4)*(-z2+z4)))/(4*Sqrt((T5+T6)**2+(T9-T10)**2+
     * (T7+T8)**2)*((T1+T2)**2+(T3-T4)**2+(T11+T12)**2)**2.5)-
     * (((T5+T6)*(T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))*
     * (2*(y2-y4)*(-y3+y4)+2*(z3-z4)*(-z2+z4)))/
     * (2*Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)**1.5))*(-phinot+ACOS(((T5+T6)*
     * (T1+T2)+(T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))/
     * (Sqrt((T5+T6)**2+(T9-T10)**2+(T7+T8)**2)*Sqrt((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))))/Sqrt(1-((T5+T6)*(T1+T2)+
     * (T9-T10)*(T3-T4)+(T7+T8)*(T11+T12))**2/(((T5+T6)**2+
     * (T9-T10)**2+(T7+T8)**2)*((T1+T2)**2+
     * (T3-T4)**2+(T11+T12)**2)))

      return
      end
c
c******************************************************************************
c  DX2Y3
c******************************************************************************
c
      subroutine dx2y3(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,phinot,ddxx)
c
c     Subroutine dx2y3
c
c     Created:  June 1998 by B.J. Lynch
c     Revised:  August 2, 1999 by J.M. Rodgers*
c     Purpose:  To determine portion of harmonic correction to hessian.
c
c     Called by:  hhess
c     Calls:
c
c     Variables defined here:
c
      implicit none     

      double precision  x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,
     *   k3,ddxx,phinot,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,
     *   t13,t14,t15,d1,d2,d3,d4,d5,d6

        t1 = (x2-x4)*(y3-y2)
        t2 = (x3-x2)*(y2-y4)
        t3 = (x2-x4)*(z3-z2)
        t4 = (x3-x2)*(z2-z4)
        t5 = (x3-x1)*(y2-y1)
        t6 = (x2-x1)*(y1-y3)
        t7 = (y3-y1)*(z2-z1)
        t8 = (y2-y1)*(z1-z3)
        t9 = (x1-x3)*(z2-z1)
        t10 = (x2-x1)*(z1-z3)
        t11 = (y4-y2)*(z3-z2)
        t12 = (y3-y2)*(z2-z4)
        t13 = (x1-x3)*(y2-y1)
        t14 = (y1-y3)*(z2-z1)
        t15 = (y2-y4)*(z3-z2)
         d1 = (t2-t1)    
         d2 = (t6-t13)    
         d3 = (t12-t15)    
         d4 = (t8-t14)    
         d5 = (t3-t4)    
         d6 = (t9-t10)    




      ddxx=(k3*(((d1*d2+d3*d4+d5*d6)*(2*d2*(x1-x2)+2*d4*(-z1+z2)))/
     -        (2.*Sqrt(d1**2 + d3**2 + d5**2)*(d2**2 + d4**2 +
     -      d6**2)**1.5) + 
     -       ((d1*d2 + d3*d4+d5*d6)*(2*d1*(-x2+x4)+2*d3*(z2-z4)))/
     -        (2.*(d1**2 + d3**2 + d5**2)**1.5*Sqrt(d2**2 + d4**2 +
     -        d6**2)) - 
     -       (d1*(x1 - x2) + d2*(-x2+x4)+d3*(-z1+z2)+d4*(z2-z4))/
     -        (Sqrt(d1**2 +d3**2+d5**2)*Sqrt(d2**2+d4**2+d6**2)))*
     -     (((d1*d2 + d3*d4+d5*d6)*(2*d2*(y1-y3)+2*d6*(-z1+z3)))/
     -        (2.*Sqrt(d1**2 + d3**2 + d5**2)*(d2**2 + d4**2 +
     -      d6**2)**1.5) + 
     -       ((d1*d2 + d3*d4 +d5*d6)*(2*d1*(-y3+y4)+2*d5*(z3-z4)))/
     -        (2.*(d1**2 + d3**2 + d5**2)**1.5*Sqrt(d2**2 + d4**2 +
     -       d6**2)) - 
     -       (d1*(y1 - y3) + d2*(-y3 + y4)+d5*(-z1+z3)+d6*(z3-z4))/
     -        (Sqrt(d1**2+d3**2+d5**2)*Sqrt(d2**2+d4**2+d6**2))))/
     -    (1 - (d1*d2+d3*d4+d5*d6)**2/((d1**2+d3**2+d5**2)*(d2**2 +
     -      d4**2 + d6**2))) - 
     -     (k3*(((d1*d2 + d3*d4+d5*d6)**2*(2*d2*(x1-x2)+2*d4*(-z1 +
     -       z2)))/
     -        ((d1**2 + d3**2 + d5**2)*(d2**2 + d4**2 + d6**2)**2)+ 
     -       ((d1*d2 + d3*d4 + d5*d6)**2*(2*d1*(-x2 + x4)+2*d3*(z2-
     -       z4)))/
     -        ((d1**2 + d3**2 + d5**2)**2*(d2**2 + d4**2 + d6**2))- 
     -       (2*(d1*d2 + d3*d4 + d5*d6)*(d1*(x1 - x2) +d2*(-x2+x4)+
     -       d3*(-z1 + z2) + d4*(z2 - z4)))/
     -        ((d1**2 + d3**2 + d5**2)*(d2**2 + d4**2 + d6**2)))*
     -     (((d1*d2 + d3*d4 + d5*d6)*(2*d2*(y1-y3)+2*d6*(-z1+z3)))/
     -        (2.*Sqrt(d1**2 + d3**2 + d5**2)*(d2**2 + d4**2 +
     -      d6**2)**1.5) + 
     -       ((d1*d2 + d3*d4+d5*d6)*(2*d1*(-y3+y4)+2*d5*(z3-z4)))/
     -        (2.*(d1**2 + d3**2 + d5**2)**1.5*Sqrt(d2**2 + d4**2+
     -       d6**2)) - 
     -       (d1*(y1 - y3) + d2*(-y3+y4)+d5*(-z1+z3)+d6*(z3-z4))/
     -        (Sqrt(d1**2+d3**2+d5**2)*Sqrt(d2**2+d4**2+d6**2)))*
     -     (-phinot + ACos((d1*d2 + d3*d4 + d5*d6)/
     -     (Sqrt(d1**2+d3**2+d5**2)*Sqrt(d2**2+d4**2+d6**2)))))/
     -     (2.*(1 - (d1*d2+d3*d4 + d5*d6)**2/((d1**2+d3**2 +
     -        d5**2)*(d2**2
     -       + d4**2 + d6**2)))**1.5) + 
     -     (k3*(((d1*d2+d3*d4+d5*d6)*(-2*d2+2*(x1-x2)*(y1-y3)))/
     -        (2.*Sqrt(d1**2 + d3**2 + d5**2)*(d2**2 + d4**2 +
     -      d6**2)**1.5) - 
     -       (t1 + t13 - t2-t6+(-x2+x4)*(y1-y3)+(x1-x2)*(-y3 +
     -       y4))/
     -        (Sqrt(d1**2+d3**2+d5**2)*Sqrt(d2**2+d4**2+d6**2)) + 
     -       ((d1*d2 + d3*d4+d5*d6)*(-2*d1+2*(-x2+x4)*(-y3+y4)))/
     -        (2.*(d1**2 + d3**2 + d5**2)**1.5*Sqrt(d2**2 +d4**2+
     -         d6**2)) - 
     -       (3*(d1*d2+d3*d4+d5*d6)*(2*d2*(x1-x2)+2*d4*(-z1+z2))*
     -          (2*d2*(y1 - y3) + 2*d6*(-z1 + z3)))/
     -        (4.*Sqrt(d1**2 + d3**2 + d5**2)*(d2**2 + d4**2 +
     -         d6**2)**2.5) - 
     -       ((d1*d2 + d3*d4 + d5*d6)*(2*d2*(y1 - y3) +2*d6*(-z1+
     -      z3))*(2*d1*(-x2 + x4) + 2*d3*(z2 - z4)))/
     -        (4.*(d1**2 + d3**2 + d5**2)**1.5*(d2**2 + d4**2 +
     -         d6**2)**1.5) + 
     -       ((2*d2*(y1 - y3) + 2*d6*(-z1 + z3))*
     -          (d1*(x1 - x2) + d2*(-x2 + x4)+d3*(-z1+z2)+d4*(z2-
     -          z4)))/
     -        (2.*Sqrt(d1**2 + d3**2 + d5**2)*(d2**2 + d4**2 +
     -       d6**2)**1.5) - 
     -       ((d1*d2 + d3*d4 + d5*d6)*(2*d2*(x1 - x2) +2*d4*(-z1+
     -        z2))*(2*d1*(-y3 + y4) + 2*d5*(z3 - z4)))/
     -        (4.*(d1**2 + d3**2 + d5**2)**1.5*(d2**2 + d4**2 +
     -       d6**2)**1.5) - 
     -       (3*(d1*d2+d3*d4+d5*d6)*(2*d1*(-x2+x4)+2*d3*(z2-z4))*
     -          (2*d1*(-y3 + y4) + 2*d5*(z3 - z4)))/
     -        (4.*(d1**2 + d3**2 + d5**2)**2.5*Sqrt(d2**2 +d4**2+
     -       d6**2)) + 
     -       ((d1*(x1 - x2) +d2*(-x2+x4)+d3*(-z1+z2)+d4*(z2-z4))*
     -          (2*d1*(-y3 + y4) + 2*d5*(z3 - z4)))/
     -        (2.*(d1**2 + d3**2 + d5**2)**1.5*Sqrt(d2**2+d4**2 +
     -       d6**2)) + 
     -       ((2*d2*(x1 - x2) + 2*d4*(-z1 + z2))*
     -          (d1*(y1 - y3) + d2*(-y3 + y4)+d5*(-z1+z3)+d6*(z3-
     -        z4)))/
     -        (2.*Sqrt(d1**2 + d3**2 + d5**2)*(d2**2+d4**2+
     -         d6**2)**1.5) + 
     -       ((2*d1*(-x2 + x4) + 2*d3*(z2 - z4))*
     -          (d1*(y1 - y3) + d2*(-y3 + y4)+d5*(-z1+z3)+d6*(z3-
     -        z4)))/
     -        (2.*(d1**2 + d3**2 + d5**2)**1.5*Sqrt(d2**2+d4**2 +
     -      d6**2)))*
     -     (-phinot + ACos((d1*d2 + d3*d4 + d5*d6)/
     -     (Sqrt(d1**2+d3**2+d5**2)*Sqrt(d2**2+d4**2+d6**2)))))/
     -  Sqrt(1-(d1*d2+d3*d4+d5*d6)**2/((d1**2+d3**2+d5**2)*(d2**2
     -        + d4**2 + d6**2)))


      return
      end
